-------------------------------------------------------------------------
------------------------ Super Meter - UI Frames ------------------------
-------------------------------------------------------------------------

function Interface:New()
	local o = {state = {}}

	setmetatable(o, self)
	self.__index = self

	o.context = UI.CreateContext("Context")
	o.context:SetVisible(SuperMeter_enabled)

	o.main = UI.CreateFrame("Frame", "SuperMeter Main", o.context)

	o.title = UI.CreateFrame("Text", "SuperMeter Main Title", o.context)
	o.title:SetParent(o.main)
	o.title:SetLayer(2)

	o.menu = UI.CreateFrame("Text", "SuperMeter Main Menu", o.context)
	o.menu:SetPoint("TOPLEFT", o.main, "TOPLEFT", 8, 2)
	o.menu:SetParent(o.main)
	o.menu:SetLayer(2)

	o.clear = UI.CreateFrame("Text", "SuperMeter Main Clear", o.context)
	o.clear:SetPoint("TOPRIGHT", o.main, "TOPRIGHT", -40.8, 2)
	o.clear:SetParent(o.main)
	o.clear:SetLayer(2)

	o.new = UI.CreateFrame("Text", "SuperMeter Main New", o.context)
	o.new:SetPoint("TOPCENTER", o.clear, "TOPCENTER", 13, 0)
	o.new:SetParent(o.main)
	o.new:SetLayer(2)

	o.force = UI.CreateFrame("Text", "SuperMeter Main Force", o.context)
	o.force:SetPoint("TOPCENTER", o.new, "TOPCENTER", 11, 0)
	o.force:SetParent(o.main)
	o.force:SetLayer(2)

	o.log = UI.CreateFrame("Text", "SuperMeter Main Log", o.context)
	o.log:SetPoint("TOPCENTER", o.force, "TOPCENTER", 11, 0)
	o.log:SetParent(o.main)
	o.log:SetLayer(2)

	o.help = UI.CreateFrame("Text", "SuperMeter Main Help", o.context)
	o.help:SetPoint("TOPCENTER", o.force, "TOPCENTER", 11, 0)
	o.help:SetParent(o.main)
	o.help:SetLayer(2)

	o.mainslider = UI.CreateFrame("RiftScrollbar", "Combat Slider", o.context)
	o.mainslider:SetPoint("CENTERLEFT", o.main, "CENTERLEFT", -20, 0)
	o.mainslider:SetParent(o.main)
	o.mainslider:SetVisible(false)

	o.menus = UI.CreateFrame("Frame", "SuperMeter Menu", o.context)
	o.menus:SetBackgroundColor(0, 0, 0, 0.88)
	o.menus:SetVisible(false)
	o.menus:SetHeight(54)
	o.menus:SetWidth(110)
	o.menus:SetLayer(20)

	o.menusbg = UI.CreateFrame("Frame", "SuperMeter Menu Background", o.context)
	o.menusbg:SetPoint("TOPCENTER", o.menus, "TOPCENTER", 0, 3)
	o.menusbg:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.menusbg:SetParent(o.menus)
	o.menusbg:SetHeight(48)
	o.menusbg:SetWidth(104)
	o.menusbg:SetLayer(22)

	o.menus1 = UI.CreateFrame("Text", "SuperMeter Menu 1", o.context)
	o.menus1:SetParent(o.menusbg)
	o.menus1:SetHeight(24)
	o.menus1:SetLayer(24)

	o.menus2 = UI.CreateFrame("Text", "SuperMeter Menu 2", o.context)
	o.menus2:SetParent(o.menusbg)
	o.menus2:SetHeight(24)
	o.menus2:SetLayer(24)

	o.menus3 = UI.CreateFrame("Text", "SuperMeter Menu 3", o.context)
	o.menus3:SetParent(o.menusbg)
	o.menus3:SetHeight(24)
	o.menus3:SetLayer(24)

	o.menus4 = UI.CreateFrame("Text", "SuperMeter Menu 4", o.context)
	o.menus4:SetParent(o.menusbg)
	o.menus4:SetHeight(24)
	o.menus4:SetLayer(24)

	o.time = UI.CreateFrame("Text", "Time Main", o.context)
	o.time:SetPoint("TOPLEFT", o.main, "TOPLEFT", 14, 26)
	o.time:SetParent(o.main)
	o.time:SetLayer(2)

	o.relation = UI.CreateFrame("Text", "Relation Main", o.context)
	o.relation:SetParent(o.main)
	o.relation:SetLayer(2)

	o.modeselectbg = UI.CreateFrame("Frame", "Mode Select Background", o.context)
	o.modeselectbg:SetBackgroundColor(0, 0, 0, 0.8)
	o.modeselectbg:SetParent(o.main)
	o.modeselectbg:SetVisible(false)
	o.modeselectbg:SetWidth(146)
	o.modeselectbg:SetLayer(8)

	o.modeselect = UI.CreateFrame("Frame", "Mode Select Main", o.context)
	o.modeselect:SetPoint("TOPCENTER", o.modeselectbg, "TOPCENTER", 0, 4)
	o.modeselect:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.modeselect:SetParent(o.modeselectbg)
	o.modeselect:SetWidth(136)
	o.modeselect:SetLayer(10)

	o.mode1select = UI.CreateFrame("Text", "Mode Select 1", o.context)
	o.mode1select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 0)
	o.mode1select:SetParent(o.modeselect)
	o.mode1select:SetHeight(20)
	o.mode1select:SetLayer(12)

	o.mode2select = UI.CreateFrame("Text", "Mode Select 2", o.context)
	o.mode2select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 20)
	o.mode2select:SetParent(o.modeselect)
	o.mode2select:SetHeight(20)
	o.mode2select:SetLayer(12)

	o.mode3select = UI.CreateFrame("Text", "Mode Select 3", o.context)
	o.mode3select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 40)
	o.mode3select:SetParent(o.modeselect)
	o.mode3select:SetHeight(20)
	o.mode3select:SetLayer(12)

	o.mode4select = UI.CreateFrame("Text", "Mode Select 4", o.context)
	o.mode4select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", -0.8, 60)
	o.mode4select:SetParent(o.modeselect)
	o.mode4select:SetHeight(20)
	o.mode4select:SetLayer(12)

	o.mode5select = UI.CreateFrame("Text", "Mode Select 5", o.context)
	o.mode5select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 80)
	o.mode5select:SetParent(o.modeselect)
	o.mode5select:SetHeight(20)
	o.mode5select:SetLayer(12)

	o.mode6select = UI.CreateFrame("Text", "Mode Select 6", o.context)
	o.mode6select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 100)
	o.mode6select:SetParent(o.modeselect)
	o.mode6select:SetHeight(20)
	o.mode6select:SetLayer(12)

	o.mode7select = UI.CreateFrame("Text", "Mode Select 7", o.context)
	o.mode7select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 120)
	o.mode7select:SetParent(o.modeselect)
	o.mode7select:SetHeight(20)
	o.mode7select:SetLayer(12)

	o.mode8select = UI.CreateFrame("Text", "Mode Select 8", o.context)
	o.mode8select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 140)
	o.mode8select:SetParent(o.modeselect)
	o.mode8select:SetHeight(20)
	o.mode8select:SetLayer(12)

	o.mode9select = UI.CreateFrame("Text", "Mode Select 9", o.context)
	o.mode9select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 160)
	o.mode9select:SetParent(o.modeselect)
	o.mode9select:SetHeight(20)
	o.mode9select:SetLayer(12)

	o.mode10select = UI.CreateFrame("Text", "Mode Select 10", o.context)
	o.mode10select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 180)
	o.mode10select:SetParent(o.modeselect)
	o.mode10select:SetHeight(20)
	o.mode10select:SetLayer(12)

	o.mode11select = UI.CreateFrame("Text", "Mode Select 11", o.context)
	o.mode11select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 200)
	o.mode11select:SetParent(o.modeselect)
	o.mode11select:SetHeight(20)
	o.mode11select:SetLayer(12)

	o.mode12select = UI.CreateFrame("Text", "Mode Select 12", o.context)
	o.mode12select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0.2, 220)
	o.mode12select:SetParent(o.modeselect)
	o.mode12select:SetHeight(20)
	o.mode12select:SetLayer(12)

	o.mode13select = UI.CreateFrame("Text", "Mode Select 13", o.context)
	o.mode13select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 240)
	o.mode13select:SetParent(o.modeselect)
	o.mode13select:SetHeight(20)
	o.mode13select:SetLayer(12)

	o.mode14select = UI.CreateFrame("Text", "Mode Select 14", o.context)
	o.mode14select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0.4, 260)
	o.mode14select:SetParent(o.modeselect)
	o.mode14select:SetHeight(20)
	o.mode14select:SetLayer(12)

	o.combatmask1 = UI.CreateFrame("Mask", "Combat Mask 1", o.context)
	o.combatmask1:SetPoint("BOTTOMLEFT", o.main, "BOTTOMLEFT", 4, -26)
	o.combatmask1:SetWidth(SuperMeter_width - 108)
	o.combatmask1:SetParent(o.main)

	o.combatmask2 = UI.CreateFrame("Mask", "Combat Mask 2", o.context)
	o.combatmask2:SetPoint("CENTERRIGHT", o.combatmask1, "CENTERRIGHT", 50, 0)
	o.combatmask2:SetParent(o.main)
	o.combatmask2:SetWidth(48)

	o.combatmask3 = UI.CreateFrame("Mask", "Combat Mask 3", o.context)
	o.combatmask3:SetPoint("CENTERRIGHT", o.combatmask2, "CENTERRIGHT", 50, 0)
	o.combatmask3:SetParent(o.main)
	o.combatmask3:SetWidth(48)

	o.combattext1 = UI.CreateFrame("Text", "Combat Text 1", o.context)
	o.combattext1:SetPoint("TOPLEFT", o.combatmask1, "TOPLEFT", 0, -2.4)
	o.combattext1:SetParent(o.combatmask1)
	o.combattext1:SetLayer(4)

	o.combattext2 = UI.CreateFrame("Text", "Combat Text 2", o.context)
	o.combattext2:SetPoint("TOPLEFT", o.combatmask2, "TOPLEFT", 0, -2.4)
	o.combattext2:SetParent(o.combatmask2)
	o.combattext2:SetWidth(42)
	o.combattext2:SetLayer(4)

	o.combattext3 = UI.CreateFrame("Text", "Combat Text 3", o.context)
	o.combattext3:SetPoint("TOPLEFT", o.combatmask3, "TOPLEFT", 0, -2.4)
	o.combattext3:SetParent(o.combatmask3)
	o.combattext3:SetWidth(42)
	o.combattext3:SetLayer(4)

	o.mode1 = UI.CreateFrame("Text", "Combat Mode 1", o.context)
	o.mode1:SetPoint("TOPCENTER", o.combatmask2, "TOPCENTER", 0, -22)
	o.mode1:SetParent(o.main)
	o.mode1:SetLayer(2)

	o.mode2 = UI.CreateFrame("Text", "Combat Mode 2", o.context)
	o.mode2:SetPoint("TOPCENTER", o.combatmask3, "TOPCENTER", 0, -22)
	o.mode2:SetParent(o.main)
	o.mode2:SetLayer(2)

	o.unitbar1 = UI.CreateFrame("Text", "Unit Bar 1", o.context)
	o.unitbar1:SetParent(o.combatmask1)
	o.unitbar1:SetLayer(2)

	o.unitbar2 = UI.CreateFrame("Text", "Unit Bar 2", o.context)
	o.unitbar2:SetParent(o.combatmask1)
	o.unitbar2:SetLayer(2)

	o.unitbar3 = UI.CreateFrame("Text", "Unit Bar 3", o.context)
	o.unitbar3:SetParent(o.combatmask1)
	o.unitbar3:SetLayer(2)

	o.unitbar4 = UI.CreateFrame("Text", "Unit Bar 4", o.context)
	o.unitbar4:SetParent(o.combatmask1)
	o.unitbar4:SetLayer(2)

	o.unitbar5 = UI.CreateFrame("Text", "Unit Bar 5", o.context)
	o.unitbar5:SetParent(o.combatmask1)
	o.unitbar5:SetLayer(2)

	o.unitbar6 = UI.CreateFrame("Text", "Unit Bar 6", o.context)
	o.unitbar6:SetParent(o.combatmask1)
	o.unitbar6:SetLayer(2)

	o.unitbar7 = UI.CreateFrame("Text", "Unit Bar 7", o.context)
	o.unitbar7:SetParent(o.combatmask1)
	o.unitbar7:SetLayer(2)

	o.unitbar8 = UI.CreateFrame("Text", "Unit Bar 8", o.context)
	o.unitbar8:SetParent(o.combatmask1)
	o.unitbar8:SetLayer(2)

	o.unitbar9 = UI.CreateFrame("Text", "Unit Bar 9", o.context)
	o.unitbar9:SetParent(o.combatmask1)
	o.unitbar9:SetLayer(2)

	o.unitbar10 = UI.CreateFrame("Text", "Unit Bar 10", o.context)
	o.unitbar10:SetParent(o.combatmask1)
	o.unitbar10:SetLayer(2)

	o.unitbar11 = UI.CreateFrame("Text", "Unit Bar 11", o.context)
	o.unitbar11:SetParent(o.combatmask1)
	o.unitbar11:SetLayer(2)

	o.unitbar12 = UI.CreateFrame("Text", "Unit Bar 12", o.context)
	o.unitbar12:SetParent(o.combatmask1)
	o.unitbar12:SetLayer(2)

	o.unitbar13 = UI.CreateFrame("Text", "Unit Bar 13", o.context)
	o.unitbar13:SetParent(o.combatmask1)
	o.unitbar13:SetLayer(2)

	o.unitbar14 = UI.CreateFrame("Text", "Unit Bar 14", o.context)
	o.unitbar14:SetParent(o.combatmask1)
	o.unitbar14:SetLayer(2)

	o.unitbar15 = UI.CreateFrame("Text", "Unit Bar 15", o.context)
	o.unitbar15:SetParent(o.combatmask1)
	o.unitbar15:SetLayer(2)

	o.unitbar16 = UI.CreateFrame("Text", "Unit Bar 16", o.context)
	o.unitbar16:SetParent(o.combatmask1)
	o.unitbar16:SetLayer(2)

	o.unitbar17 = UI.CreateFrame("Text", "Unit Bar 17", o.context)
	o.unitbar17:SetParent(o.combatmask1)
	o.unitbar17:SetLayer(2)

	o.unitbar18 = UI.CreateFrame("Text", "Unit Bar 18", o.context)
	o.unitbar18:SetParent(o.combatmask1)
	o.unitbar18:SetLayer(2)

	o.unitbar19 = UI.CreateFrame("Text", "Unit Bar 19", o.context)
	o.unitbar19:SetParent(o.combatmask1)
	o.unitbar19:SetLayer(2)

	o.unitbar20 = UI.CreateFrame("Text", "Unit Bar 20", o.context)
	o.unitbar20:SetParent(o.combatmask1)
	o.unitbar20:SetLayer(2)

	o.combattotal1 = UI.CreateFrame("Mask", "Combat Total 1", o.context)
	o.combattotal1:SetPoint("BOTTOMCENTER", o.main, "BOTTOMCENTER", -50, -4)
	o.combattotal1:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.combattotal1:SetWidth(SuperMeter_width - 108)
	o.combattotal1:SetParent(o.main)
	o.combattotal1:SetHeight(19)

	o.combattotal2 = UI.CreateFrame("Mask", "Combat Total 2", o.context)
	o.combattotal2:SetPoint("CENTERRIGHT", o.combattotal1, "CENTERRIGHT", 50, 0)
	o.combattotal2:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.combattotal2:SetParent(o.main)
	o.combattotal2:SetHeight(19)
	o.combattotal2:SetWidth(48)

	o.combattotal3 = UI.CreateFrame("Mask", "Combat Total 3", o.context)
	o.combattotal3:SetPoint("CENTERRIGHT", o.combattotal2, "CENTERRIGHT", 50, 0)
	o.combattotal3:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.combattotal3:SetParent(o.main)
	o.combattotal3:SetHeight(19)
	o.combattotal3:SetWidth(48)

	o.totaltext1 = UI.CreateFrame("Text", "Combat Total Text 1", o.context)
	o.totaltext1:SetParent(o.combattotal1)
	o.totaltext1:SetLayer(2)

	o.totaltext2 = UI.CreateFrame("Text", "Combat Total Text 2", o.context)
	o.totaltext2:SetParent(o.combattotal2)
	o.totaltext2:SetWidth(42)
	o.totaltext2:SetLayer(2)

	o.totaltext3 = UI.CreateFrame("Text", "Combat Total Text 3", o.context)
	o.totaltext3:SetParent(o.combattotal3)
	o.totaltext3:SetWidth(42)
	o.totaltext3:SetLayer(2)

	o.copy = UI.CreateFrame("RiftTextfield", "SuperMeter Copy Text", o.context)
	o.copy:SetParent(o.combattotal1)
	o.copy:SetVisible(false)
	o.copy:SetHeight(20.84)

	o.plog = UI.CreateFrame("Frame", "Player Logs Main", o.context)
	o.plog:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_logX, SuperMeter_logY)
	o.plog:SetBackgroundColor(0, 0, 0, 0.8)
	o.plog:SetVisible(false)
	o.plog:SetHeight(308)

	o.plogtitlebg = UI.CreateFrame("Frame", "Player Logs Title Background", o.context)
	o.plogtitlebg:SetPoint("TOPCENTER", o.plog, "TOPCENTER", 0, 4)
	o.plogtitlebg:SetBackgroundColor(0, 0.4, 0.8, 0.28)
	o.plogtitlebg:SetParent(o.plog)
	o.plogtitlebg:SetHeight(48)

	o.plogtitle = UI.CreateFrame("Text", "Player Logs Title", o.context)
	o.plogtitle:SetPoint("TOPCENTER", o.plogtitlebg, "TOPCENTER", 0, 0)
	o.plogtitle:SetParent(o.plog)
	o.plogtitle:SetFontSize(16)
	o.plogtitle:SetHeight(24)
	o.plogtitle:SetLayer(4)

	o.plogtitle2 = UI.CreateFrame("Text", "Player Logs Secondary Title", o.context)
	o.plogtitle2:SetPoint("TOPCENTER", o.plogtitle, "TOPCENTER", 0, 24)
	o.plogtitle2:SetParent(o.plog)
	o.plogtitle2:SetFontSize(14)
	o.plogtitle2:SetHeight(24)
	o.plogtitle2:SetLayer(4)

	o.plogoutbg = UI.CreateFrame("Frame", "Player Logs Output Background", o.context)
	o.plogoutbg:SetPoint("TOPCENTER", o.plog, "TOPCENTER", 0, 56)
	o.plogoutbg:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.plogoutbg:SetParent(o.plog)
	o.plogoutbg:SetHeight(248)
	o.plogoutbg:SetLayer(4)

	o.plogmask = UI.CreateFrame("Mask", "Player Logs Mask", o.context)
	o.plogmask:SetPoint("TOPCENTER", o.plogoutbg, "TOPCENTER", -4, 6)
	o.plogmask:SetParent(o.plog)
	o.plogmask:SetHeight(236)
	o.plogmask:SetLayer(6)

	o.plogtext = UI.CreateFrame("Text", "Player Logs Output", o.context)
	o.plogtext:SetFontColor(0.88, 0.48, 0.0, 2)
	o.plogtext:SetParent(o.plogmask)
	o.plogtext:SetFontSize(14)
	o.plogtext:SetLayer(8)

	o.plogslider = UI.CreateFrame("RiftScrollbar", "Player Logs Slider", o.context)
	o.plogslider:SetPoint("CENTERLEFT", o.plogmask, "CENTERLEFT", 14, 0)
	o.plogslider:SetParent(o.plogmask)
	o.plogslider:SetVisible(false)
	o.plogslider:SetHeight(236)
	o.plogslider:SetWidth(18)

	o.infotip = UI.CreateFrame("Frame", "Infotip Main", o.context)
	o.infotip:SetBackgroundColor(0, 0, 0, 2)
	o.infotip:SetVisible(false)
	o.infotip:SetLayer(6)

	o.infotiptext = UI.CreateFrame("Text", "Infotip Text", o.context)
	o.infotiptext:SetPoint("TOPLEFT", o.infotip, "TOPLEFT", 8.8, 4)
	o.infotiptext:SetParent(o.infotip)
	o.infotiptext:SetLayer(8)

	o.datatip = UI.CreateFrame("Frame", "Datatip Main", o.context)
	o.datatip:SetBackgroundColor(0, 0, 0, 2)
	o.datatip:SetVisible(false)
	o.datatip:SetLayer(6)

	o.datatiptext = UI.CreateFrame("Text", "Datatip Text", o.context)
	o.datatiptext:SetPoint("TOPLEFT", o.datatip, "TOPLEFT", 8.8, 4)
	o.datatiptext:SetParent(o.datatip)
	o.datatiptext:SetLayer(8)

	o.tipbg = UI.CreateFrame("Frame", "Tip Background", o.context)
	o.tipbg:SetPoint("BOTTOMCENTER", o.infotip, "BOTTOMCENTER", 0, 0.8)
	o.tipbg:SetVisible(false)
	o.tipbg:SetLayer(4)

	o.smgrm = UI.CreateFrame("Frame", "Session Manager Main", o.context)
	o.smgrm:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	o.smgrm:SetBackgroundColor(0, 0, 0, 0.88)
	o.smgrm:SetVisible(false)
	o.smgrm:SetHeight(484)
	o.smgrm:SetWidth(760)
	o.smgrm:SetLayer(8)

	o.smgrmbg = UI.CreateFrame("Frame", "Session Manager Main Background", o.context)
	o.smgrmbg:SetPoint("TOPCENTER", o.smgrm, "TOPCENTER", 0, 60)
	o.smgrmbg:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.smgrmbg:SetParent(o.smgrm)
	o.smgrmbg:SetHeight(414)
	o.smgrmbg:SetWidth(740)
	o.smgrmbg:SetLayer(10)

	o.smgrtbh = UI.CreateFrame("Frame", "Session Manager Title Background", o.context)
	o.smgrtbh:SetPoint("TOPCENTER", o.smgrm, "TOPCENTER", 0, 10)
	o.smgrtbh:SetBackgroundColor(0, 0.4, 0.8, 0.28)
	o.smgrtbh:SetParent(o.smgrm)
	o.smgrtbh:SetWidth(740)
	o.smgrtbh:SetLayer(12)

	o.smgrt = UI.CreateFrame("Text", "Session Manager Title", o.context)
	o.smgrt:SetPoint("TOPCENTER", o.smgrm, "TOPCENTER", 0, 14.8)
	o.smgrt:SetParent(o.smgrm)
	o.smgrt:SetFontSize(20)
	o.smgrt:SetLayer(14)

	o.smgrcm = UI.CreateFrame("Mask", "Session Manager Current Mask", o.context)
	o.smgrcm:SetPoint("TOPLEFT", o.smgrmbg, "TOPLEFT", 12, 46)
	o.smgrcm:SetBackgroundColor(0, 0.4, 0.8, 0.088)
	o.smgrcm:SetParent(o.smgrm)
	o.smgrcm:SetHeight(302)
	o.smgrcm:SetWidth(350)
	o.smgrcm:SetLayer(14)

	o.smgrsm = UI.CreateFrame("Mask", "Session Manager Saved Mask", o.context)
	o.smgrsm:SetPoint("TOPRIGHT", o.smgrmbg, "TOPRIGHT", -12, 46)
	o.smgrsm:SetBackgroundColor(0, 0.4, 0.8, 0.088)
	o.smgrsm:SetParent(o.smgrm)
	o.smgrsm:SetHeight(302)
	o.smgrsm:SetWidth(350)
	o.smgrsm:SetLayer(14)

	o.smgrct = UI.CreateFrame("Text", "Current Title", o.context)
	o.smgrct:SetPoint("TOPCENTER", o.smgrcm, "TOPCENTER", 0, -36)
	o.smgrct:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.smgrct:SetParent(o.smgrm)
	o.smgrct:SetFontSize(16)
	o.smgrct:SetWidth(350)
	o.smgrct:SetLayer(14)

	o.smgrst = UI.CreateFrame("Text", "Saved Title", o.context)
	o.smgrst:SetPoint("TOPCENTER", o.smgrsm, "TOPCENTER", 0, -36)
	o.smgrst:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.smgrst:SetParent(o.smgrm)
	o.smgrst:SetFontSize(16)
	o.smgrst:SetWidth(350)
	o.smgrst:SetLayer(14)

	o.smgrc = UI.CreateFrame("Text", "Session Manager Current Text", o.context)
	o.smgrc:SetPoint("TOPRIGHT", o.smgrcm, "TOPRIGHT", 0, 0)
	o.smgrc:SetParent(o.smgrcm)
	o.smgrc:SetFontSize(14)
	o.smgrc:SetWidth(320)
	o.smgrc:SetLayer(16)

	o.smgrs = UI.CreateFrame("Text", "Session Manager Saved Text", o.context)
	o.smgrs:SetPoint("TOPRIGHT", o.smgrsm, "TOPRIGHT", 0, 0)
	o.smgrs:SetParent(o.smgrsm)
	o.smgrs:SetFontSize(14)
	o.smgrs:SetWidth(320)
	o.smgrs:SetLayer(16)

	o.smgrcs = UI.CreateFrame("RiftScrollbar", "Session Manager Current Slider", o.context)
	o.smgrcs:SetPoint("CENTERLEFT", o.smgrcm, "CENTERLEFT", 6.8, 0)
	o.smgrcs:SetParent(o.smgrcm)
	o.smgrcs:SetVisible(false)
	o.smgrcs:SetHeight(298)
	o.smgrcs:SetWidth(18)

	o.smgrss = UI.CreateFrame("RiftScrollbar", "Session Manager Saved Slider", o.context)
	o.smgrss:SetPoint("CENTERLEFT", o.smgrsm, "CENTERLEFT", 6.8, 0)
	o.smgrss:SetParent(o.smgrsm)
	o.smgrss:SetVisible(false)
	o.smgrss:SetHeight(298)
	o.smgrss:SetWidth(18)

	o.smgrp = UI.CreateFrame("Frame", "Session Manager Panel", o.context)
	o.smgrp:SetPoint("BOTTOMCENTER", o.smgrmbg, "BOTTOMCENTER", 0, -12)
	o.smgrp:SetBackgroundColor(0, 0.4, 0.8, 0.088)
	o.smgrp:SetParent(o.smgrm)
	o.smgrp:SetWidth(716)
	o.smgrp:SetLayer(14)

	o.smgri = UI.CreateFrame("RiftButton", "Session Manager Import|Export", o.context)
	o.smgri:SetPoint("LEFTCENTER", o.smgrp, "LEFTCENTER", 88, 0)
	o.smgri:SetParent(o.smgrm)
	o.smgri:SetWidth(120)
	o.smgri:SetLayer(16)

	o.smgrv = UI.CreateFrame("RiftButton", "Session Manager View", o.context)
	o.smgrv:SetPoint("CENTER", o.smgrp, "CENTER", 0, 0)
	o.smgrv:SetParent(o.smgrm)
	o.smgrv:SetWidth(120)
	o.smgrv:SetLayer(16)

	o.smgrd = UI.CreateFrame("RiftButton", "Session Manager Delete", o.context)
	o.smgrd:SetPoint("RIGHTCENTER", o.smgrp, "RIGHTCENTER", -88, 0)
	o.smgrd:SetParent(o.smgrm)
	o.smgrd:SetWidth(120)
	o.smgrd:SetLayer(16)

	function o.main.Event:WheelBack()
		if SuperMeter_scroll and SuperMeter_interval then
			if o.combattext1:GetHeight() > o.combatmask1:GetHeight() then
				o.mainslider:Nudge(SuperMeter_interval)
			end
		end
	end

	function o.main.Event:WheelForward()
		if SuperMeter_scroll and SuperMeter_interval then
			if o.combattext1:GetHeight() > o.combatmask1:GetHeight() then
				o.mainslider:Nudge(-SuperMeter_interval)
			end
		end
	end

	function o.mainslider.Event:ScrollbarChange()
		if SuperMeter_scroll and SuperMeter_interval then
			local offsetY = (o.mainslider:GetPosition() - o.mainslider:GetPosition() * 2) - 2.4
			o.combattext1:SetPoint("TOPLEFT", o.combatmask1, "TOPLEFT", 0, offsetY)
			o.combattext2:SetPoint("TOPLEFT", o.combatmask2, "TOPLEFT", 0, offsetY)
			o.combattext3:SetPoint("TOPLEFT", o.combatmask3, "TOPLEFT", 0, offsetY)
		end
	end

	function o.title.Event:LeftDown()
		if SuperMeter_sticky then return end
		local mouse = Inspect.Mouse()
		o.state.mouseDown1 = true
		o.state.startX1 = o.main:GetLeft()
		o.state.startY1 = o.main:GetTop()
		o.state.mouseStartX1 = mouse.x
		o.state.mouseStartY1 = mouse.y
		o.main:SetBackgroundColor(0.2, 0.2, 0.2, SuperMeter_alpha - 0.2)
	end

	function o.title.Event:MouseMove()
		if o.state.mouseDown1 then
			o.main:SetHeight(74)
			o.menus:SetVisible(false)
			o.state.mouseMove1 = true
			o.combatmask1:SetHeight(0)
			o.combatmask2:SetHeight(0)
			o.combatmask3:SetHeight(0)
			local mouse = Inspect.Mouse()
			SuperMeter_x = mouse.x - o.state.mouseStartX1 + o.state.startX1
			SuperMeter_y = mouse.y - o.state.mouseStartY1 + o.state.startY1
			o.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y)
		end
		local text = SuperMeter.Tooltip(true)
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.title.Event:LeftUp()
		if o.state.mouseDown1 then
			o.state.mouseDown1 = nil
			o.main:SetBackgroundColor(0, 0, 0, SuperMeter_alpha)
		end
		o.state.mouseMove1 = nil
		SuperMeter.UI.Interface:Display()
	end

	function o.title.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.title.Event:MiddleClick()
		SuperMeter_sticky = false
		SuperMeter_abilityUnit = false
		if SuperMeter_fontSize == 14 then
			SuperMeter_fontSize = 13
		else
			SuperMeter_fontSize = 14
		end
		SuperMeter.UI.Interface:SortSlots(nil, true)
		o.infotip:SetVisible(false)
		o.datatip:SetVisible(false)
		o.tipbg:SetVisible(false)
	end

	function o.title.Event:RightClick()
		SuperMeter_growUp = not SuperMeter_growUp
		if o.combattext1:GetHeight() <= 8 then
			if SuperMeter_growUp then
				print(SuperMeter_region1)
			else
				print(SuperMeter_region2)
			end
		end
		SuperMeter.UI.Interface:Display()
	end

	function o.title.Event:WheelBack()
		if SuperMeter_sticky then return end
		if SuperMeter_width <= 240 then return end
		SuperMeter_width = SuperMeter_width - 2
		SuperMeter_x = SuperMeter_x + 1
		SuperMeter.UI.Interface:Display()
	end

	function o.title.Event:WheelForward()
		if SuperMeter_sticky then return end
		if SuperMeter_width >= 288 then return end
		SuperMeter_width = SuperMeter_width + 2
		SuperMeter_x = SuperMeter_x - 1
		SuperMeter.UI.Interface:Display()
	end

	function o.clear.Event:LeftClick()
		SuperMeter.Reset()
		SuperMeter.UI.Interface:Display(true)
		SuperMeter.UI.Interface:ChangeSession()
		SuperMeter.UI.Interface:ManagerSessions()
		SuperMeter.UI.Interface:SortSlots(nil, true)
	end

	function o.clear.Event:MouseMove()
		local text = SuperMeter.Tooltip(nil, true)
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.clear.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.new.Event:LeftClick()
		SuperMeter_split = true
		SuperMeter.Combat()
	end

	function o.new.Event:MouseMove()
		local text = SuperMeter.Tooltip(nil, nil, true)
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.new.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.force.Event:LeftClick()
		SuperMeter_force = true
		SuperMeter.Combat()
	end

	function o.force.Event:MouseMove()
		local text = SuperMeter.Tooltip(nil, nil, nil, true)
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.force.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.log.Event:LeftClick()
		o.plogtitle:SetText("Super Meter Player Session Logs")
		SuperMeter_logShowing = not SuperMeter_logShowing
		o.plog:SetVisible(not o.plog:GetVisible())
		SuperMeter_table = nil
		SuperMeter_unit = nil
		SuperMeter.Log()
	end

	function o.log.Event:MouseMove()
		local text = SuperMeter.Tooltip(nil, nil, nil, nil, true)
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.log.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.help.Event:LeftClick()
		SuperMeter.Help()
	end

	function o.help.Event:MouseMove()
		local text = SuperMeter.Tooltip(nil, nil, nil, nil, nil, true)
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.help.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.menu.Event:LeftClick()
		o.menus2:SetText("< ")
		o.menus4:SetText(" >")
		SuperMeter.UI.Interface:SortSlots()
		o.menus:SetVisible(not o.menus:GetVisible())
		o.menus:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_menuX, SuperMeter_menuY)
	end

	function o.menu.Event:RightClick()
		if not SuperMeter_inCombat then
			o.smgrcs:SetRange(0, 0)
			o.smgrss:SetRange(0, 0)
			o.smgri:SetEnabled(false)
			o.smgrv:SetEnabled(false)
			o.smgrd:SetEnabled(false)
			o.smgrm:SetVisible(not o.smgrm:GetVisible())
		end
		SuperMeter_savedSelected = nil
		SuperMeter_currentSelected = nil
		SuperMeter.UI.Interface:ManagerSessions()
	end

	function o.menu.Event:MiddleClick()
		SuperMeter_menuX = o.main:GetLeft()
		SuperMeter_menuY = o.main:GetTop() + 20
		o.menus:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_menuX, SuperMeter_menuY)
	end

	function o.menusbg.Event:LeftDown()
		local mouse = Inspect.Mouse()
		o.state.mouseDown2 = true
		o.state.startX2 = o.menus:GetLeft()
		o.state.startY2 = o.menus:GetTop()
		o.state.mouseStartX2 = mouse.x
		o.state.mouseStartY2 = mouse.y
	end

	function o.menusbg.Event:MouseMove()
		if o.state.mouseDown2 then
			local mouse = Inspect.Mouse()
			SuperMeter_menuX = mouse.x - o.state.mouseStartX2 + o.state.startX2
			SuperMeter_menuY = mouse.y - o.state.mouseStartY2 + o.state.startY2
			o.menus:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_menuX, SuperMeter_menuY)
		end
	end

	function o.menusbg.Event:LeftUp()
		if o.state.mouseDown2 then
			o.state.mouseDown2 = nil
		end
	end

	function o.menus1.Event:LeftClick()
		SuperMeter.UI.Interface:SortSlots(true)
	end

	function o.menus2.Event:LeftClick()
		if SuperMeter.State.sessionOffset < #SuperMeter.State.sessions - 1 then
			SuperMeter.State.sessionOffset = SuperMeter.State.sessionOffset + 1
			SuperMeter.UI.Interface:SortSlots(nil, true)
			SuperMeter.UI.Interface:ChangeSession()
		end
	end

	function o.menus3.Event:LeftClick()
		if not SuperMeter_inCombat then
			SuperMeter_showall = not SuperMeter_showall
			if SuperMeter_showall then
				o.menus3:SetText("ALL")
				SuperMeter.Merge(true)
			else
				SuperMeter.Merge()
			end
		end
	end

	function o.menus3.Event:RightClick()
		if not SuperMeter_inCombat then
			o.smgrcs:SetRange(0, 0)
			o.smgrss:SetRange(0, 0)
			o.smgri:SetEnabled(false)
			o.smgrv:SetEnabled(false)
			o.smgrd:SetEnabled(false)
			o.smgrm:SetVisible(not o.smgrm:GetVisible())
		end
		SuperMeter_savedSelected = nil
		SuperMeter_currentSelected = nil
		SuperMeter.UI.Interface:ManagerSessions()
	end

	function o.menus3.Event:MouseMove()
		local text = SuperMeter.Tooltip(nil, nil, nil, nil, nil, nil, true)
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.menus3.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.menus4.Event:LeftClick()
		if SuperMeter.State.sessionOffset > 0 then
			SuperMeter.State.sessionOffset = SuperMeter.State.sessionOffset - 1
			SuperMeter.UI.Interface:SortSlots(nil, true)
			SuperMeter.UI.Interface:ChangeSession()
		end
	end

	function o.relation.Event:LeftClick()
		if SuperMeter_side == "Allies" then
			SuperMeter_side = "Enemies"
		else
			SuperMeter_side = "Allies"
		end
		SuperMeter.UI.Interface:SortSlots(nil, true)
		SuperMeter.UI.Interface:Relation()
	end

	function o.mode1.Event:LeftClick()
		SuperMeter_mode = SuperMeter_mode1
		SuperMeter.UI.Interface:Update()
	end

	function o.mode1.Event:RightClick()
		local session = SuperMeter.Session()
		local list = {}
		if SuperMeter_side == "Allies" then
			list = session.allies
		else
			list = session.enemies
		end
		if o.modeselect:GetVisible() then
			SuperMeter_mode1Change = true
			SuperMeter_mode2Change = nil
		else
			SuperMeter_mode1Change = nil
			SuperMeter_mode2Change = nil
		end
		if SuperMeter_growUp and list and o.combatmask1:GetHeight() < 12 * (o.combattext1:GetHeight() / #list) then
			o.modeselectbg:SetPoint("TOPRIGHT", o.mode1, "TOPRIGHT", 0, -294)
		else
			o.modeselectbg:SetPoint("TOPRIGHT", o.mode1, "TOPRIGHT", 0, 24)
		end
		SuperMeter.UI.Interface:ModeShowText()
		o.modeselectbg:SetVisible(not o.modeselectbg:GetVisible())
	end

	function o.mode1.Event:MouseMove()
		SuperMeter.UI.Interface:ModeDescription(true)
	end

	function o.mode1.Event:MouseOut()
		if SuperMeter_value and not SuperMeter_showPlayer then
			o.totaltext1:SetText("Total:")
		elseif not SuperMeter_showPlayer then
			o.totaltext1:SetText("")
		end
		SuperMeter_modeDesc = nil
	end

	function o.mode2.Event:LeftClick()
		SuperMeter_mode = SuperMeter_mode2
		SuperMeter.UI.Interface:Update()
	end

	function o.mode2.Event:RightClick()
		local session = SuperMeter.Session()
		local list = {}
		if SuperMeter_side == "Allies" then
			list = session.allies
		else
			list = session.enemies
		end
		if o.modeselect:GetVisible() then
			SuperMeter_mode1Change = nil
			SuperMeter_mode2Change = true
		else
			SuperMeter_mode1Change = nil
			SuperMeter_mode2Change = nil
		end
		if SuperMeter_growUp and list and o.combatmask1:GetHeight() < 12 * (o.combattext1:GetHeight() / #list) then
			o.modeselectbg:SetPoint("TOPRIGHT", o.mode1, "TOPRIGHT", 50, -294)
		else
			o.modeselectbg:SetPoint("TOPRIGHT", o.mode1, "TOPRIGHT", 50, 24)
		end
		SuperMeter.UI.Interface:ModeShowText()
		o.modeselectbg:SetVisible(not o.modeselectbg:GetVisible())
	end

	function o.mode2.Event:MouseMove()
		SuperMeter.UI.Interface:ModeDescription(nil, true)
	end

	function o.mode2.Event:MouseOut()
		if SuperMeter_value and not SuperMeter_showPlayer then
			o.totaltext1:SetText("Total:")
		elseif not SuperMeter_showPlayer then
			o.totaltext1:SetText("")
		end
		SuperMeter_modeDesc = nil
	end

	function o.mode1select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "DPS"
			end
			SuperMeter_mode1 = "DPS"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "DPS"
			end
			SuperMeter_mode2 = "DPS"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode2select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "DMG"
			end
			SuperMeter_mode1 = "DMG"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "DMG"
			end
			SuperMeter_mode2 = "DMG"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode3select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "DTN"
			end
			SuperMeter_mode1 = "DTN"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "DTN"
			end
			SuperMeter_mode2 = "DTN"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode4select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "OKL"
			end
			SuperMeter_mode1 = "OKL"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "OKL"
			end
			SuperMeter_mode2 = "OKL"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode5select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "HPS"
			end
			SuperMeter_mode1 = "HPS"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "HPS"
			end
			SuperMeter_mode2 = "HPS"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode6select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "HLG"
			end
			SuperMeter_mode1 = "HLG"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "HLG"
			end
			SuperMeter_mode2 = "HLG"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode7select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "HTN"
			end
			SuperMeter_mode1 = "HTN"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "HTN"
			end
			SuperMeter_mode2 = "HTN"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode8select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "OPS"
			end
			SuperMeter_mode1 = "OPS"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "OPS"
			end
			SuperMeter_mode2 = "OPS"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode9select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "OHG"
			end
			SuperMeter_mode1 = "OHG"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "OHG"
			end
			SuperMeter_mode2 = "OHG"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode10select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "ASB"
			end
			SuperMeter_mode1 = "ASB"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "ASB"
			end
			SuperMeter_mode2 = "ASB"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode11select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "AVD"
			end
			SuperMeter_mode1 = "AVD"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "AVD"
			end
			SuperMeter_mode2 = "AVD"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode12select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "BLK"
			end
			SuperMeter_mode1 = "BLK"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "BLK"
			end
			SuperMeter_mode2 = "BLK"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode13select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "DFT"
			end
			SuperMeter_mode1 = "DFT"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "DFT"
			end
			SuperMeter_mode2 = "DFT"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode14select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "MSD"
			end
			SuperMeter_mode1 = "MSD"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = nil
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "MSD"
			end
			SuperMeter_mode2 = "MSD"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = nil
		end
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.modeselectbg.Event:MouseIn()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.modeselectbg.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.mode1select.Event:MouseIn()
		o.mode1select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode2select.Event:MouseIn()
		o.mode2select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode3select.Event:MouseIn()
		o.mode3select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode4select.Event:MouseIn()
		o.mode4select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode5select.Event:MouseIn()
		o.mode5select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode6select.Event:MouseIn()
		o.mode6select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode7select.Event:MouseIn()
		o.mode7select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode8select.Event:MouseIn()
		o.mode8select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode9select.Event:MouseIn()
		o.mode9select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode10select.Event:MouseIn()
		o.mode10select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode11select.Event:MouseIn()
		o.mode11select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode12select.Event:MouseIn()
		o.mode12select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode13select.Event:MouseIn()
		o.mode13select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode14select.Event:MouseIn()
		o.mode14select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode1select.Event:MouseOut()
		o.mode1select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode2select.Event:MouseOut()
		o.mode2select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode3select.Event:MouseOut()
		o.mode3select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode4select.Event:MouseOut()
		o.mode4select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode5select.Event:MouseOut()
		o.mode5select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode6select.Event:MouseOut()
		o.mode6select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode7select.Event:MouseOut()
		o.mode7select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode8select.Event:MouseOut()
		o.mode8select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode9select.Event:MouseOut()
		o.mode9select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode10select.Event:MouseOut()
		o.mode10select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode11select.Event:MouseOut()
		o.mode11select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode12select.Event:MouseOut()
		o.mode12select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode13select.Event:MouseOut()
		o.mode13select:SetFontColor(1, 1, 1, 1)
	end

	function o.mode14select.Event:MouseOut()
		o.mode14select:SetFontColor(1, 1, 1, 1)
	end

	function o.combatmask1.Event:LeftClick()
		SuperMeter.UI.Interface:SortSlots(true)
	end

	function o.combatmask1.Event:MiddleClick()
		if SuperMeter_display == "None" then
			SuperMeter_display = "Bars"
			o.combattext1:SetVisible(true)
		elseif SuperMeter_display == "Bars" then
			SuperMeter_display = "Calling"
			o.combattext1:SetVisible(false)
		elseif SuperMeter_display == "Calling" then
			SuperMeter_display = "None"
			o.combattext1:SetVisible(true)
		end
		SuperMeter.UI.Interface:Display()
	end

	function o.combatmask1.Event:RightClick()
		local unit = SuperMeter.UI.Interface:GetUnit(true)
		if unit and unit.combatlog[1] then
			o.plogtitle:SetText("Super Meter Player Session Logs")
			SuperMeter_logShowing = not SuperMeter_logShowing
			o.plog:SetVisible(not o.plog:GetVisible())
			SuperMeter.Log(unit)
		end
		if not SuperMeter_logShowing then
			SuperMeter_table = nil
			SuperMeter_unit = nil
		end
	end

	function o.combatmask1.Event:MouseMove()
		local text = SuperMeter.Tooltip(nil, nil, nil, nil, nil, nil, nil, true)
		if text then
			SuperMeter.UI.Interface:InfotipShow(text)
		else
			SuperMeter.UI.Interface:InfotipHide()
		end
	end

	function o.combatmask1.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.combattext2.Event:LeftClick()
		SuperMeter_ModeRequest = SuperMeter_mode1
		SuperMeter.UI.Interface:TipColours(true)
		SuperMeter.UI.Interface:AbilitySort(nil)
		SuperMeter_sticky = not SuperMeter_sticky
		SuperMeter.UI.Interface:Position()
	end

	function o.combattext2.Event:RightClick()
		SuperMeter_ModeRequest = SuperMeter_mode1
		SuperMeter.UI.Interface:TipColours(true)
		SuperMeter.UI.Interface:AbilitySort(true)
		SuperMeter.UI.Interface:Position()
	end

	function o.combattext2.Event:MouseMove()
		if SuperMeter_sticky then return end
		if SuperMeter_tipclick then return end
		SuperMeter_ModeRequest = SuperMeter_mode1
		SuperMeter.UI.Interface:TipColours(true)
		SuperMeter.UI.Interface:AbilitySort()
	end

	function o.combattext2.Event:MouseOut()
		SuperMeter.UI.Interface:TipColours()
		SuperMeter.UI.Interface:DatatipHide()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.combattext3.Event:LeftClick()
		SuperMeter_ModeRequest = SuperMeter_mode2
		SuperMeter.UI.Interface:TipColours(true)
		SuperMeter.UI.Interface:AbilitySort(nil)
		SuperMeter_sticky = not SuperMeter_sticky
		SuperMeter.UI.Interface:Position()
	end

	function o.combattext3.Event:RightClick()
		SuperMeter_ModeRequest = SuperMeter_mode2
		SuperMeter.UI.Interface:TipColours(true)
		SuperMeter.UI.Interface:AbilitySort(true)
		SuperMeter.UI.Interface:Position()
	end

	function o.combattext3.Event:MouseMove()
		if SuperMeter_sticky then return end
		if SuperMeter_tipclick then return end
		SuperMeter_ModeRequest = SuperMeter_mode2
		SuperMeter.UI.Interface:TipColours(true)
		SuperMeter.UI.Interface:AbilitySort()
	end

	function o.combattext3.Event:MouseOut()
		SuperMeter.UI.Interface:TipColours()
		SuperMeter.UI.Interface:DatatipHide()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.combattotal1.Event:LeftClick()
		SuperMeter_showPlayer = not SuperMeter_showPlayer
		SuperMeter.UI.Interface:SetTime()
		SuperMeter.UI.Interface:Display()
	end

	function o.combattotal1.Event:RightClick()
		SuperMeter_minimal = not SuperMeter_minimal
		SuperMeter.UI.Interface:SetTime()
		SuperMeter.UI.Interface:Display()
	end

	function o.combattotal2.Event:LeftClick()
		if SuperMeter_showPlayer then return end
		o.copy:SetVisible(not o.copy:GetVisible())
		o.totaltext1:SetVisible(not o.copy:GetVisible())
		SuperMeter.UI.Interface:FrameSort(true, true, nil)
	end

	function o.combattotal3.Event:LeftClick()
		if SuperMeter_showPlayer then return end
		o.copy:SetVisible(not o.copy:GetVisible())
		o.totaltext1:SetVisible(not o.copy:GetVisible())
		SuperMeter.UI.Interface:FrameSort(true, nil, true)
	end

	function o.copy.Event:KeyUp()
		o.totaltext1:SetVisible(true)
		o.copy:SetKeyFocus(false)
		o.copy:SetVisible(false)
		o.copy:SetText("")
	end

	function o.plogtitle.Event:LeftDown()
		local mouse = Inspect.Mouse()
		o.state.mouseDown3 = true
		o.state.startX3 = o.plog:GetLeft()
		o.state.startY3 = o.plog:GetTop()
		o.state.mouseStartX3 = mouse.x
		o.state.mouseStartY3 = mouse.y
		o.plog:SetBackgroundColor(0.2, 0.2, 0.2, 0.6)
	end

	function o.plogtitle.Event:MouseMove()
		if o.state.mouseDown3 then
			local mouse = Inspect.Mouse()
			SuperMeter_logX = mouse.x - o.state.mouseStartX3 + o.state.startX3
			SuperMeter_logY = mouse.y - o.state.mouseStartY3 + o.state.startY3
			o.plog:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_logX, SuperMeter_logY)
		end
	end

	function o.plogtitle.Event:LeftUp()
		if o.state.mouseDown3 then
			o.plog:SetBackgroundColor(0, 0, 0, 0.8)
			o.state.mouseDown3 = nil
		end
	end

	function o.plogtitle2.Event:LeftClick()
		SuperMeter_table = nil
		SuperMeter_unit = nil
		SuperMeter.Log()
	end

	function o.plog.Event:WheelBack()
		if o.plogtext:GetHeight() > o.plogmask:GetHeight() then
			o.plogslider:Nudge(20)
		end
	end

	function o.plog.Event:WheelForward()
		if o.plogtext:GetHeight() > o.plogmask:GetHeight() then
			o.plogslider:Nudge(-20)
		end
	end

	function o.plogtext.Event:LeftClick()
		SuperMeter.UI.Interface:GetEntry(SuperMeter_table)
	end

	function o.plogslider.Event:ScrollbarChange()
		local offsetY = o.plogslider:GetPosition() - o.plogslider:GetPosition() * 2
		o.plogtext:SetPoint("TOPLEFT", o.plogmask, "TOPLEFT", 40, offsetY - 2.8)
	end

	function o.smgrc.Event:LeftClick()
		SuperMeter.UI.Interface:GetSession(true)
		if SuperMeter_currentSelected and not SuperMeter_savedSelected then
			o.smgrv:SetEnabled(true)
		else
			o.smgrv:SetEnabled(false)
		end
	end

	function o.smgrs.Event:LeftClick()
		SuperMeter.UI.Interface:GetSession(nil, true)
		if SuperMeter_currentSelected and not SuperMeter_savedSelected then
			o.smgrv:SetEnabled(true)
		else
			o.smgrv:SetEnabled(false)
		end
	end

	function o.smgrcs.Event:ScrollbarChange()
		local offsetY = o.smgrcs:GetPosition() - o.smgrcs:GetPosition() * 2
		o.smgrc:SetPoint("TOPRIGHT", o.smgrcm, "TOPRIGHT", 0, offsetY)
	end

	function o.smgrcm.Event:WheelBack()
		if o.smgrcm:GetHeight() < o.smgrc:GetHeight() then
			o.smgrcs:Nudge(20)
		end
	end

	function o.smgrcm.Event:WheelForward()
		if o.smgrcm:GetHeight() < o.smgrc:GetHeight() then
			o.smgrcs:Nudge(-20)
		end
	end

	function o.smgrss.Event:ScrollbarChange()
		local offsetY = o.smgrss:GetPosition() - o.smgrss:GetPosition() * 2
		o.smgrs:SetPoint("TOPRIGHT", o.smgrsm, "TOPRIGHT", 0, offsetY)
	end

	function o.smgrsm.Event:WheelBack()
		if o.smgrsm:GetHeight() < o.smgrs:GetHeight() then
			o.smgrss:Nudge(20)
		end
	end

	function o.smgrsm.Event:WheelForward()
		if o.smgrsm:GetHeight() < o.smgrs:GetHeight() then
			o.smgrss:Nudge(-20)
		end
	end

	function o.smgri.Event:LeftClick()
		if not o.smgri:GetEnabled() then return end
		if SuperMeter_savedSelected then
			if SuperMeter.State.sessionOffset > 0 then
				SuperMeter.State.sessionOffset = SuperMeter.State.sessionOffset + 1
			end
			SuperMeter.State.sessionIndex = SuperMeter.State.sessionIndex + 1
			table.insert(SuperMeter.State.sessions, SuperMeter_savedSelected)
			SuperMeter_savedSelected = nil
		end
		if SuperMeter_currentSelected then
			table.insert(SuperMeter_export, SuperMeter_currentSelected)
			SuperMeter_currentSelected = nil
		end
		o.smgri:SetEnabled(false)
		o.smgrv:SetEnabled(false)
		o.smgrd:SetEnabled(false)
		SuperMeter.UI.Interface:ChangeSession()
		SuperMeter.UI.Interface:ManagerSessions()
	end

	function o.smgrv.Event:LeftClick()
		if not o.smgrv:GetEnabled() then return end
		for k,v in pairs (SuperMeter.State.sessions) do
			if v == SuperMeter_currentSelected then
				SuperMeter.State.sessionOffset = #SuperMeter.State.sessions - k
			end
		end
		o.smgri:SetEnabled(false)
		o.smgrv:SetEnabled(false)
		o.smgrd:SetEnabled(false)
		SuperMeter_currentSelected = nil
		SuperMeter.UI.Interface:ChangeSession()
		SuperMeter.UI.Interface:ManagerSessions()
	end

	function o.smgrd.Event:LeftClick()
		if not o.smgrd:GetEnabled() then return end
		if SuperMeter_currentSelected then
			for i = 1, #SuperMeter.State.sessions do
				if SuperMeter.State.sessions[i] == SuperMeter_currentSelected then
					table.remove(SuperMeter.State.sessions, i)
					SuperMeter_currentSelected = nil
				end
			end
		end
		if SuperMeter_savedSelected then
			for i = 1, #SuperMeter_export do
				if SuperMeter_export[i] == SuperMeter_savedSelected then
					table.remove(SuperMeter_export, i)
					SuperMeter_savedSelected = nil
				end
			end
		end
		if not SuperMeter.State.sessions[SuperMeter.State.sessionIndex] then
			if SuperMeter.State.sessions[SuperMeter.State.sessionIndex + 1] then
				SuperMeter.State.sessionIndex = SuperMeter.State.sessionIndex + 1
				if SuperMeter.State.sessionOffset > 0 then
					SuperMeter.State.sessionOffset = SuperMeter.State.sessionOffset + 1
				end
			elseif SuperMeter.State.sessions[SuperMeter.State.sessionIndex - 1] then
				SuperMeter.State.sessionIndex = SuperMeter.State.sessionIndex - 1
				if SuperMeter.State.sessionOffset > 0 then
					SuperMeter.State.sessionOffset = SuperMeter.State.sessionOffset - 1
				end
			else
				SuperMeter.State.sessionIndex = 0
				SuperMeter.State.sessionOffset = 0
			end
		end
		o.smgri:SetEnabled(false)
		o.smgrv:SetEnabled(false)
		o.smgrd:SetEnabled(false)
		SuperMeter.UI.Interface:ResetTime()
		SuperMeter.UI.Interface:ChangeSession()
		SuperMeter.UI.Interface:ManagerSessions()
	end

	return o
end

function Interface:Toggle()
	self.context:SetVisible(not self.context:GetVisible())
end

function Interface:Position()
	local x = self.tipbg:GetLeft() + ((self.tipbg:GetWidth() - self.main:GetWidth()) / 2) + 2
	local y = self.tipbg:GetTop() - self.main:GetHeight() - 2

	if SuperMeter_sticky and self.main:GetBottom() > self.tipbg:GetTop() and self.main:GetRight() > self.tipbg:GetLeft() then
		self.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x, y)
	end

	if not SuperMeter_sticky and SuperMeter_growUp then
		self.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y - self.main:GetHeight() + 74)
	elseif not SuperMeter_sticky then
		self.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y)
	end
end

function Interface:SetTime()
	if not SuperMeter_enabled then return end
	if self.state.mouseDown1 then return end

	local current = SuperMeter.Session(true)
	local session = SuperMeter.Session()
	local time = session.combatTime

	if time and time > 0 then
		local text = "Time " .. SuperMeter.Time(time)
		
		if not SuperMeter_minimal and text:len() > 10 then
			text = SuperMeter.Time(time)
		end
		
		if SuperMeter_minimal and not SuperMeter_showPlayer then
			self.totaltext1:SetText(text)
		else
			self.time:SetText(text)
		end
	end
end

function Interface:ResetTime()
	self.time:SetText("Time 00:00")
end

function Interface:Relation()
	if SuperMeter_side == "Allies" then
		self.relation:SetText("Allies")
		self.combatmask1:SetBackgroundColor(0, 0.8, 0.2, 0.068)
		self.combatmask2:SetBackgroundColor(0, 0.8, 0.2, 0.068)
		self.combatmask3:SetBackgroundColor(0, 0.8, 0.2, 0.068)
	else
		self.relation:SetText("Enemies")
		self.combatmask1:SetBackgroundColor(0.8, 0, 0, 0.068)
		self.combatmask2:SetBackgroundColor(0.8, 0, 0, 0.068)
		self.combatmask3:SetBackgroundColor(0.8, 0, 0, 0.068)
	end

	if SuperMeter_sticky then
		SuperMeter_sticky = nil
		self.combattext2.Event:MouseOut()
	end

	self:TipColours()
	self:Update()
end

function Interface:Display(reset)
	local display = SuperMeter_display
	local font = SuperMeter_fontSize
	local view = SuperMeter_minimal

	local height = self:Line(true)
	local position = self:Line(nil, true)
	local change = self:Line(nil, nil, true)

	self.title:SetFontSize(font + 2)
	self.menu:SetFontSize(font)
	self.clear:SetFontSize(font)
	self.new:SetFontSize(font)
	self.force:SetFontSize(font)
	self.log:SetFontSize(font)
	self.help:SetFontSize(font)
	self.menus1:SetFontSize(font)
	self.menus2:SetFontSize(font)
	self.menus3:SetFontSize(font)
	self.menus4:SetFontSize(font)
	self.time:SetFontSize(font)
	self.relation:SetFontSize(font)
	self.mode1:SetFontSize(font)
	self.mode2:SetFontSize(font)
	self.mode1select:SetFontSize(font)
	self.mode2select:SetFontSize(font)
	self.mode3select:SetFontSize(font)
	self.mode4select:SetFontSize(font)
	self.mode5select:SetFontSize(font)
	self.mode6select:SetFontSize(font)
	self.mode7select:SetFontSize(font)
	self.mode8select:SetFontSize(font)
	self.mode9select:SetFontSize(font)
	self.mode10select:SetFontSize(font)
	self.mode11select:SetFontSize(font)
	self.mode12select:SetFontSize(font)
	self.mode13select:SetFontSize(font)
	self.mode14select:SetFontSize(font)
	self.combattext1:SetFontSize(font)
	self.combattext2:SetFontSize(font)
	self.combattext3:SetFontSize(font)
	self.totaltext1:SetFontSize(font)
	self.totaltext2:SetFontSize(font)
	self.totaltext3:SetFontSize(font)
	self.infotiptext:SetFontSize(font)
	self.datatiptext:SetFontSize(font)

	self.title:SetVisible(not view)
	self.menu:SetVisible(not view)
	self.clear:SetVisible(not view)
	self.new:SetVisible(not view)
	self.force:SetVisible(not view)
	self.log:SetVisible(not view)
	self.help:SetVisible(not view)
	self.time:SetVisible(not view)
	self.relation:SetVisible(not view)
	self.mode1:SetVisible(not view)
	self.mode2:SetVisible(not view)

	if not view then
		self.help:SetVisible(not SuperMeter_logEnabled)
		self.log:SetVisible(SuperMeter_logEnabled)
	end

	if reset then
		self.mode1:SetText(SuperMeter_mode1)
		self.mode2:SetText(SuperMeter_mode2)
		self.title:SetText("Super Meter")
		self.time:SetText("Time 00:00")
		self.menus3:SetText("00 - 00")
		self.menu:SetText("MENU")
		self.force:SetText("F")
		self.clear:SetText("C")
		self.help:SetText("H")
		self.new:SetText("N")
		self.log:SetText("D")
	end

	if display == "None" then
		self.combattext1:SetFontColor(1, 1, 1, 1)
		self.combattext1:SetVisible(true)
	elseif display == "Bars" then
		self.combattext1:SetFontColor(1, 1, 1, 1)
		self.combattext1:SetVisible(true)
	elseif display == "Calling" then
		self.combattext1:SetFontColor(1, 1, 1, 1)
		self.combattext1:SetVisible(false)
	end

	if height and height > 2 then
		self.unitbar1:SetPoint("TOPLEFT", self.combattext1, "TOPLEFT", 0, position)
		self.unitbar1:SetFontSize(font)
		self.unitbar1:SetHeight(height)
		
		self.unitbar2:SetPoint("BOTTOMLEFT", self.unitbar1, "BOTTOMLEFT", 0, change + height)
		self.unitbar2:SetFontSize(font)
		self.unitbar2:SetHeight(height)
		
		self.unitbar3:SetPoint("BOTTOMLEFT", self.unitbar2, "BOTTOMLEFT", 0, change + height)
		self.unitbar3:SetFontSize(font)
		self.unitbar3:SetHeight(height)
		
		self.unitbar4:SetPoint("BOTTOMLEFT", self.unitbar3, "BOTTOMLEFT", 0, change + height)
		self.unitbar4:SetFontSize(font)
		self.unitbar4:SetHeight(height)
		
		self.unitbar5:SetPoint("BOTTOMLEFT", self.unitbar4, "BOTTOMLEFT", 0, change + height)
		self.unitbar5:SetFontSize(font)
		self.unitbar5:SetHeight(height)
		
		self.unitbar6:SetPoint("BOTTOMLEFT", self.unitbar5, "BOTTOMLEFT", 0, change + height)
		self.unitbar6:SetFontSize(font)
		self.unitbar6:SetHeight(height)
		
		self.unitbar7:SetPoint("BOTTOMLEFT", self.unitbar6, "BOTTOMLEFT", 0, change + height)
		self.unitbar7:SetFontSize(font)
		self.unitbar7:SetHeight(height)
		
		self.unitbar8:SetPoint("BOTTOMLEFT", self.unitbar7, "BOTTOMLEFT", 0, change + height)
		self.unitbar8:SetFontSize(font)
		self.unitbar8:SetHeight(height)
		
		self.unitbar9:SetPoint("BOTTOMLEFT", self.unitbar8, "BOTTOMLEFT", 0, change + height)
		self.unitbar9:SetFontSize(font)
		self.unitbar9:SetHeight(height)
		
		self.unitbar10:SetPoint("BOTTOMLEFT", self.unitbar9, "BOTTOMLEFT", 0, change + height)
		self.unitbar10:SetFontSize(font)
		self.unitbar10:SetHeight(height)
		
		self.unitbar11:SetPoint("BOTTOMLEFT", self.unitbar10, "BOTTOMLEFT", 0, change + height)
		self.unitbar11:SetFontSize(font)
		self.unitbar11:SetHeight(height)
		
		self.unitbar12:SetPoint("BOTTOMLEFT", self.unitbar11, "BOTTOMLEFT", 0, change + height)
		self.unitbar12:SetFontSize(font)
		self.unitbar12:SetHeight(height)
		
		self.unitbar13:SetPoint("BOTTOMLEFT", self.unitbar12, "BOTTOMLEFT", 0, change + height)
		self.unitbar13:SetFontSize(font)
		self.unitbar13:SetHeight(height)
		
		self.unitbar14:SetPoint("BOTTOMLEFT", self.unitbar13, "BOTTOMLEFT", 0, change + height)
		self.unitbar14:SetFontSize(font)
		self.unitbar14:SetHeight(height)
		
		self.unitbar15:SetPoint("BOTTOMLEFT", self.unitbar14, "BOTTOMLEFT", 0, change + height)
		self.unitbar15:SetFontSize(font)
		self.unitbar15:SetHeight(height)
		
		self.unitbar16:SetPoint("BOTTOMLEFT", self.unitbar15, "BOTTOMLEFT", 0, change + height)
		self.unitbar16:SetFontSize(font)
		self.unitbar16:SetHeight(height)
		
		self.unitbar17:SetPoint("BOTTOMLEFT", self.unitbar16, "BOTTOMLEFT", 0, change + height)
		self.unitbar17:SetFontSize(font)
		self.unitbar17:SetHeight(height)
		
		self.unitbar18:SetPoint("BOTTOMLEFT", self.unitbar17, "BOTTOMLEFT", 0, change + height)
		self.unitbar18:SetFontSize(font)
		self.unitbar18:SetHeight(height)
		
		self.unitbar19:SetPoint("BOTTOMLEFT", self.unitbar18, "BOTTOMLEFT", 0, change + height)
		self.unitbar19:SetFontSize(font)
		self.unitbar19:SetHeight(height)
		
		self.unitbar20:SetPoint("BOTTOMLEFT", self.unitbar19, "BOTTOMLEFT", 0, change + height)
		self.unitbar20:SetFontSize(font)
		self.unitbar20:SetHeight(height)
	end

	if font == 14 then
		self.title:SetPoint("TOPCENTER", self.main, "TOPCENTER", 0, 0)
		self.relation:SetPoint("TOPCENTER", self.main, "TOPCENTER", 0, 26)
		self.totaltext1:SetPoint("BOTTOMLEFT", self.combatmask1, "BOTTOMLEFT", 0, 24.2)
		self.totaltext2:SetPoint("BOTTOMLEFT", self.combatmask2, "BOTTOMLEFT", 0, 24.2)
		self.totaltext3:SetPoint("BOTTOMLEFT", self.combatmask3, "BOTTOMLEFT", 0, 24.2)
	else
		self.title:SetPoint("TOPCENTER", self.main, "TOPCENTER", -2, 0)
		self.relation:SetPoint("TOPCENTER", self.main, "TOPCENTER", -2, 26)
		self.totaltext1:SetPoint("BOTTOMLEFT", self.combatmask1, "BOTTOMLEFT", 0, 22.8)
		self.totaltext2:SetPoint("BOTTOMLEFT", self.combatmask2, "BOTTOMLEFT", 0, 22.8)
		self.totaltext3:SetPoint("BOTTOMLEFT", self.combatmask3, "BOTTOMLEFT", 0, 22.8)
	end

	self.copy:SetPoint("BOTTOMLEFT", self.main, "BOTTOMLEFT", 0, -2.2)
	self.main:SetBackgroundColor(0, 0, 0, SuperMeter_alpha)
	self.combattotal1:SetWidth(SuperMeter_width - 108)
	self.combatmask1:SetWidth(SuperMeter_width - 108)
	self.main:SetWidth(SuperMeter_width)

	self:Update()
end

function Interface:SortSlots(change, setRange)
	local sessions = SuperMeter.State.sessions
	local slots = SuperMeter_maxSlots

	if slots == 5.02 then
		if change then
			SuperMeter_maxSlots = 5
			self.menus1:SetText("5 Slots")
			self.menus1:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", 0.28, 2)
		elseif not setRange then
			self.menus1:SetText("Self")
			self.menus1:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", -0.2, 2)
		end
	elseif slots == 5 then
		if change then
			SuperMeter_maxSlots = 10
			self.menus1:SetText("10 Slots")
			self.menus1:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", -0.8, 2)
		elseif not setRange then
			self.menus1:SetText("5 Slots")
			self.menus1:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", 0.28, 2)
		end
	elseif slots == 10 then
		if change then
			SuperMeter_maxSlots = 20
			self.menus1:SetText("20 Slots")
			self.menus1:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", 0, 2)
		elseif not setRange then
			self.menus1:SetText("10 Slots")
			self.menus1:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", -0.8, 2)
		end
	elseif slots == 20 then
		if change then
			SuperMeter_maxSlots = 5.02
			self.menus1:SetText("Self")
			self.menus1:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", -0.2, 2)
		elseif not setRange then
			self.menus1:SetText("20 Slots")
			self.menus1:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", 0, 2)
		end
	end

	if #sessions <= 0 or SuperMeter_showall then
		self.menus3:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", 0.40, 24)
	elseif #sessions == 1 then
		self.menus3:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", 1.28, 24)
	elseif #sessions <= 9 then
		self.menus3:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", 0.80, 24)
	elseif #sessions == 10 then
		self.menus3:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", -0.6, 24)
	elseif #sessions == 11 then
		self.menus3:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", 0.48, 24)
	elseif #sessions <= 19 then
		self.menus3:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", -0.2, 24)
	elseif #sessions >= 100 then
		self.menus3:SetPoint("TOPCENTER", self.menusbg, "TOPCENTER", -0.28, 24)
	end

	if #SuperMeter.State.sessions >= 100 then
		self.menus2:SetPoint("BOTTOMLEFT", self.menusbg, "BOTTOMLEFT", 4, -0.8)
		self.menus4:SetPoint("BOTTOMRIGHT", self.menusbg, "BOTTOMRIGHT", -4, -0.8)
	else
		self.menus2:SetPoint("BOTTOMLEFT", self.menusbg, "BOTTOMLEFT", 12, -0.8)
		self.menus4:SetPoint("BOTTOMRIGHT", self.menusbg, "BOTTOMRIGHT", -12, -0.8)
	end

	if SuperMeter_menuX == 0 and SuperMeter_menuY == 0 then
		SuperMeter_menuY = self.main:GetTop() + 20
		SuperMeter_menuX = self.main:GetLeft()
	end

	if change or setRange then
		self.mainslider:SetRange(0, 0)
		self:Display()
	end
end

function Interface:ResetText()
	self.totaltext1:SetVisible(true)
	self.combattext1:SetText("")
	self.combattext2:SetText("")
	self.combattext3:SetText("")
	self.copy:SetKeyFocus(false)
	self.totaltext1:SetText("")
	self.totaltext2:SetText("")
	self.totaltext3:SetText("")
	self.copy:SetVisible(false)
	self.copy:SetText("")
end

function Interface:CombatText(nameText, mode1Text, mode2Text)
	if self.state.mouseDown1 then return end

	local session = SuperMeter.Session()

	self.combattext1:SetText(nameText)
	self.combattext2:SetText(mode1Text)
	self.combattext3:SetText(mode2Text)

	local frame = self.combattext1:GetHeight()
	local alpha = SuperMeter_alpha - 0.4
	local display = SuperMeter_display
	local slots = SuperMeter_maxSlots
	local player = SuperMeter.Player

	local height = 0
	local width = 0
	local total = 0

	local colours = {}
	local list = {}

	if SuperMeter_side == "Allies" then
		list = session.allies
	else
		list = session.enemies
	end

	if #list > slots then
		if slots == 5 then
			SuperMeter_scroll = true
			height = ((frame - 6.00) / #list) * slots - 2.50
			SuperMeter_interval = (frame - 5.60 - height) / (#list - slots)
			
			if frame - 5.60 - height > 0 then
				self.mainslider:SetRange(0, frame - 5.60 - height)
			end
		end
		if slots == 5.02 then
			SuperMeter_scroll = nil
			height = ((frame - 6.00) / #list) * #list - 0.00
			SuperMeter_interval = (frame - 6.00 - height) / (#list - slots)
			
			if frame - 6.00 - height > 0 then
				self.mainslider:SetRange(0, frame - 6.00 - height)
			end
		end
		if slots == 10 then
			SuperMeter_scroll = true
			height = ((frame - 6.00) / #list) * slots - 2.00
			SuperMeter_interval = (frame - 6.00 - height) / (#list - slots)
			
			if frame - 6.00 - height > 0 then
				self.mainslider:SetRange(0, frame - 6.00 - height)
			end
		end
	else
		SuperMeter_scroll = nil
		height = ((frame - 6.00) / #list) * #list
		SuperMeter_interval = (frame - 6.00) / #list
		
		if frame - 6.00 > 0 then
			self.mainslider:SetRange(0, frame - 6.00)
		end
	end

	if SuperMeter_minimal then
		if list and list[1] then
			self.main:SetHeight(height + 30.0)
		else
			self.main:SetHeight(26.8)
		end
	else
		if list and list[1] then
			self.main:SetHeight(height + 74)
		else
			self.main:SetHeight(74)
		end
	end

	if #list > 0 then
		self.combatmask1:SetHeight(height)
		self.combatmask2:SetHeight(height)
		self.combatmask3:SetHeight(height)
	else
		self.combatmask1:SetHeight(0)
		self.combatmask2:SetHeight(0)
		self.combatmask3:SetHeight(0)
	end

	if SuperMeter_growUp and not SuperMeter_sticky then
		self.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y - self.main:GetHeight() + 74)
	elseif not SuperMeter_sticky then
		self.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y)
	end

	if SuperMeter_display == "Bars" then
		width = self.combatmask1:GetWidth()
	else
		width = SuperMeter_width
	end

	if list[1] and list[1].mode then
		total = list[1].mode
	end

	for i = 1, #list do
		if list[i].name == player.name and SuperMeter_self then
			table.insert(colours, {r = 0.00, g = 0.60, b = 1.00})
		elseif list[i].calling == "cleric" then
			table.insert(colours, {r = 0.46, g = 0.88, b = 0.00})
		elseif list[i].calling == "mage" then
			table.insert(colours, {r = 0.68, g = 0.40, b = 1.00})
		elseif list[i].calling == "rogue" then
			table.insert(colours, {r = 1.00, g = 0.86, b = 0.00})
		elseif list[i].calling == "warrior" then
			table.insert(colours, {r = 1.00, g = 0.00, b = 0.00})
		else
			table.insert(colours, {r = 0.00, g = 0.48, b = 0.88})
		end
	end

	if list[1] then
		if display == "Bars" then
			if total and list[1].mode and list[1].mode / total > 0 then
				self.unitbar1:SetText("")
				self.unitbar1:SetVisible(true)
				self.unitbar1:SetFontColor(1, 1, 1, 1)
				self.unitbar1:SetWidth(list[1].mode / total * width)
				self.unitbar1:SetBackgroundColor(colours[1].r, colours[1].g, colours[1].b, alpha)
			else
				self.unitbar1:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar1:SetWidth(width)
			self.unitbar1:SetVisible(true)
			self.unitbar1:SetText(list[1].name)
			self.unitbar1:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar1:SetFontColor(colours[1].r, colours[1].g, colours[1].b, alpha)
		else
			self.unitbar1:SetVisible(false)
		end
	else
		self.unitbar1:SetVisible(false)
	end

	if list[2] then
		if display == "Bars" then
			if total and list[2].mode and list[2].mode / total > 0 then
				self.unitbar2:SetText("")
				self.unitbar2:SetVisible(true)
				self.unitbar2:SetFontColor(1, 1, 1, 1)
				self.unitbar2:SetWidth(list[2].mode / total * width)
				self.unitbar2:SetBackgroundColor(colours[2].r, colours[2].g, colours[2].b, alpha)
			else
				self.unitbar2:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar2:SetWidth(width)
			self.unitbar2:SetVisible(true)
			self.unitbar2:SetText(list[2].name)
			self.unitbar2:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar2:SetFontColor(colours[2].r, colours[2].g, colours[2].b, alpha)
		else
			self.unitbar2:SetVisible(false)
		end
	else
		self.unitbar2:SetVisible(false)
	end

	if list[3] then
		if display == "Bars" then
			if total and list[3].mode and list[3].mode / total > 0 then
				self.unitbar3:SetText("")
				self.unitbar3:SetVisible(true)
				self.unitbar3:SetFontColor(1, 1, 1, 1)
				self.unitbar3:SetWidth(list[3].mode / total * width)
				self.unitbar3:SetBackgroundColor(colours[3].r, colours[3].g, colours[3].b, alpha)
			else
				self.unitbar3:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar3:SetWidth(width)
			self.unitbar3:SetVisible(true)
			self.unitbar3:SetText(list[3].name)
			self.unitbar3:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar3:SetFontColor(colours[3].r, colours[3].g, colours[3].b, alpha)
		else
			self.unitbar3:SetVisible(false)
		end
	else
		self.unitbar3:SetVisible(false)
	end

	if list[4] then
		if display == "Bars" then
			if total and list[4].mode and list[4].mode / total > 0 then
				self.unitbar4:SetText("")
				self.unitbar4:SetVisible(true)
				self.unitbar4:SetFontColor(1, 1, 1, 1)
				self.unitbar4:SetWidth(list[4].mode / total * width)
				self.unitbar4:SetBackgroundColor(colours[4].r, colours[4].g, colours[4].b, alpha)
			else
				self.unitbar4:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar4:SetWidth(width)
			self.unitbar4:SetVisible(true)
			self.unitbar4:SetText(list[4].name)
			self.unitbar4:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar4:SetFontColor(colours[4].r, colours[4].g, colours[4].b, alpha)
		else
			self.unitbar4:SetVisible(false)
		end
	else
		self.unitbar4:SetVisible(false)
	end

	if list[5] then
		if display == "Bars" then
			if total and list[5].mode and list[5].mode / total > 0 then
				self.unitbar5:SetText("")
				self.unitbar5:SetVisible(true)
				self.unitbar5:SetFontColor(1, 1, 1, 1)
				self.unitbar5:SetWidth(list[5].mode / total * width)
				self.unitbar5:SetBackgroundColor(colours[5].r, colours[5].g, colours[5].b, alpha)
			else
				self.unitbar5:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar5:SetWidth(width)
			self.unitbar5:SetVisible(true)
			self.unitbar5:SetText(list[5].name)
			self.unitbar5:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar5:SetFontColor(colours[5].r, colours[5].g, colours[5].b, alpha)
		else
			self.unitbar5:SetVisible(false)
		end
	else
		self.unitbar5:SetVisible(false)
	end

	if list[6] then
		if display == "Bars" then
			if total and list[6].mode and list[6].mode / total > 0 then
				self.unitbar6:SetText("")
				self.unitbar6:SetVisible(true)
				self.unitbar6:SetFontColor(1, 1, 1, 1)
				self.unitbar6:SetWidth(list[6].mode / total * width)
				self.unitbar6:SetBackgroundColor(colours[6].r, colours[6].g, colours[6].b, alpha)
			else
				self.unitbar6:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar6:SetWidth(width)
			self.unitbar6:SetVisible(true)
			self.unitbar6:SetText(list[6].name)
			self.unitbar6:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar6:SetFontColor(colours[6].r, colours[6].g, colours[6].b, alpha)
		else
			self.unitbar6:SetVisible(false)
		end
	else
		self.unitbar6:SetVisible(false)
	end

	if list[7] then
		if display == "Bars" then
			if total and list[7].mode and list[7].mode / total > 0 then
				self.unitbar7:SetText("")
				self.unitbar7:SetVisible(true)
				self.unitbar7:SetFontColor(1, 1, 1, 1)
				self.unitbar7:SetWidth(list[7].mode / total * width)
				self.unitbar7:SetBackgroundColor(colours[7].r, colours[7].g, colours[7].b, alpha)
			else
				self.unitbar7:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar7:SetWidth(width)
			self.unitbar7:SetVisible(true)
			self.unitbar7:SetText(list[7].name)
			self.unitbar7:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar7:SetFontColor(colours[7].r, colours[7].g, colours[7].b, alpha)
		else
			self.unitbar7:SetVisible(false)
		end
	else
		self.unitbar7:SetVisible(false)
	end

	if list[8] then
		if display == "Bars" then
			if total and list[8].mode and list[8].mode / total > 0 then
				self.unitbar8:SetText("")
				self.unitbar8:SetVisible(true)
				self.unitbar8:SetFontColor(1, 1, 1, 1)
				self.unitbar8:SetWidth(list[8].mode / total * width)
				self.unitbar8:SetBackgroundColor(colours[8].r, colours[8].g, colours[8].b, alpha)
			else
				self.unitbar8:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar8:SetWidth(width)
			self.unitbar8:SetVisible(true)
			self.unitbar8:SetText(list[8].name)
			self.unitbar8:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar8:SetFontColor(colours[8].r, colours[8].g, colours[8].b, alpha)
		else
			self.unitbar8:SetVisible(false)
		end
	else
		self.unitbar8:SetVisible(false)
	end

	if list[9] then
		if display == "Bars" then
			if total and list[9].mode and list[9].mode / total > 0 then
				self.unitbar9:SetText("")
				self.unitbar9:SetVisible(true)
				self.unitbar9:SetFontColor(1, 1, 1, 1)
				self.unitbar9:SetWidth(list[9].mode / total * width)
				self.unitbar9:SetBackgroundColor(colours[9].r, colours[9].g, colours[9].b, alpha)
			else
				self.unitbar9:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar9:SetWidth(width)
			self.unitbar9:SetVisible(true)
			self.unitbar9:SetText(list[9].name)
			self.unitbar9:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar9:SetFontColor(colours[9].r, colours[9].g, colours[9].b, alpha)
		else
			self.unitbar9:SetVisible(false)
		end
	else
		self.unitbar9:SetVisible(false)
	end

	if list[10] then
		if display == "Bars" then
			if total and list[10].mode and list[10].mode / total > 0 then
				self.unitbar10:SetText("")
				self.unitbar10:SetVisible(true)
				self.unitbar10:SetFontColor(1, 1, 1, 1)
				self.unitbar10:SetWidth(list[10].mode / total * width)
				self.unitbar10:SetBackgroundColor(colours[10].r, colours[10].g, colours[10].b, alpha)
			else
				self.unitbar10:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar10:SetWidth(width)
			self.unitbar10:SetVisible(true)
			self.unitbar10:SetText(list[10].name)
			self.unitbar10:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar10:SetFontColor(colours[10].r, colours[10].g, colours[10].b, alpha)
		else
			self.unitbar10:SetVisible(false)
		end
	else
		self.unitbar10:SetVisible(false)
	end

	if list[11] then
		if display == "Bars" then
			if total and list[11].mode and list[11].mode / total > 0 then
				self.unitbar11:SetText("")
				self.unitbar11:SetVisible(true)
				self.unitbar11:SetFontColor(1, 1, 1, 1)
				self.unitbar11:SetWidth(list[11].mode / total * width)
				self.unitbar11:SetBackgroundColor(colours[11].r, colours[11].g, colours[11].b, alpha)
			else
				self.unitbar11:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar11:SetWidth(width)
			self.unitbar11:SetVisible(true)
			self.unitbar11:SetText(list[11].name)
			self.unitbar11:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar11:SetFontColor(colours[11].r, colours[11].g, colours[11].b, alpha)
		else
			self.unitbar11:SetVisible(false)
		end
	else
		self.unitbar11:SetVisible(false)
	end

	if list[12] then
		if display == "Bars" then
			if total and list[12].mode and list[12].mode / total > 0 then
				self.unitbar12:SetText("")
				self.unitbar12:SetVisible(true)
				self.unitbar12:SetFontColor(1, 1, 1, 1)
				self.unitbar12:SetWidth(list[12].mode / total * width)
				self.unitbar12:SetBackgroundColor(colours[12].r, colours[12].g, colours[12].b, alpha)
			else
				self.unitbar12:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar12:SetWidth(width)
			self.unitbar12:SetVisible(true)
			self.unitbar12:SetText(list[12].name)
			self.unitbar12:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar12:SetFontColor(colours[12].r, colours[12].g, colours[12].b, alpha)
		else
			self.unitbar12:SetVisible(false)
		end
	else
		self.unitbar12:SetVisible(false)
	end

	if list[13] then
		if display == "Bars" then
			if total and list[13].mode and list[13].mode / total > 0 then
				self.unitbar13:SetText("")
				self.unitbar13:SetVisible(true)
				self.unitbar13:SetFontColor(1, 1, 1, 1)
				self.unitbar13:SetWidth(list[13].mode / total * width)
				self.unitbar13:SetBackgroundColor(colours[13].r, colours[13].g, colours[13].b, alpha)
			else
				self.unitbar13:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar13:SetWidth(width)
			self.unitbar13:SetVisible(true)
			self.unitbar13:SetText(list[13].name)
			self.unitbar13:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar13:SetFontColor(colours[13].r, colours[13].g, colours[13].b, alpha)
		else
			self.unitbar13:SetVisible(false)
		end
	else
		self.unitbar13:SetVisible(false)
	end

	if list[14] then
		if display == "Bars" then
			if total and list[14].mode and list[14].mode / total > 0 then
				self.unitbar14:SetText("")
				self.unitbar14:SetVisible(true)
				self.unitbar14:SetFontColor(1, 1, 1, 1)
				self.unitbar14:SetWidth(list[14].mode / total * width)
				self.unitbar14:SetBackgroundColor(colours[14].r, colours[14].g, colours[14].b, alpha)
			else
				self.unitbar14:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar14:SetWidth(width)
			self.unitbar14:SetVisible(true)
			self.unitbar14:SetText(list[14].name)
			self.unitbar14:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar14:SetFontColor(colours[14].r, colours[14].g, colours[14].b, alpha)
		else
			self.unitbar14:SetVisible(false)
		end
	else
		self.unitbar14:SetVisible(false)
	end

	if list[15] then
		if display == "Bars" then
			if total and list[15].mode and list[15].mode / total > 0 then
				self.unitbar15:SetText("")
				self.unitbar15:SetVisible(true)
				self.unitbar15:SetFontColor(1, 1, 1, 1)
				self.unitbar15:SetWidth(list[15].mode / total * width)
				self.unitbar15:SetBackgroundColor(colours[15].r, colours[15].g, colours[15].b, alpha)
			else
				self.unitbar15:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar15:SetWidth(width)
			self.unitbar15:SetVisible(true)
			self.unitbar15:SetText(list[15].name)
			self.unitbar15:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar15:SetFontColor(colours[15].r, colours[15].g, colours[15].b, alpha)
		else
			self.unitbar15:SetVisible(false)
		end
	else
		self.unitbar15:SetVisible(false)
	end

	if list[16] then
		if display == "Bars" then
			if total and list[16].mode and list[16].mode / total > 0 then
				self.unitbar16:SetText("")
				self.unitbar16:SetVisible(true)
				self.unitbar16:SetFontColor(1, 1, 1, 1)
				self.unitbar16:SetWidth(list[16].mode / total * width)
				self.unitbar16:SetBackgroundColor(colours[16].r, colours[16].g, colours[16].b, alpha)
			else
				self.unitbar16:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar16:SetWidth(width)
			self.unitbar16:SetVisible(true)
			self.unitbar16:SetText(list[16].name)
			self.unitbar16:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar16:SetFontColor(colours[16].r, colours[16].g, colours[16].b, alpha)
		else
			self.unitbar16:SetVisible(false)
		end
	else
		self.unitbar16:SetVisible(false)
	end

	if list[17] then
		if display == "Bars" then
			if total and list[17].mode and list[17].mode / total > 0 then
				self.unitbar17:SetText("")
				self.unitbar17:SetVisible(true)
				self.unitbar17:SetFontColor(1, 1, 1, 1)
				self.unitbar17:SetWidth(list[17].mode / total * width)
				self.unitbar17:SetBackgroundColor(colours[17].r, colours[17].g, colours[17].b, alpha)
			else
				self.unitbar17:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar17:SetWidth(width)
			self.unitbar17:SetVisible(true)
			self.unitbar17:SetText(list[17].name)
			self.unitbar17:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar17:SetFontColor(colours[17].r, colours[17].g, colours[17].b, alpha)
		else
			self.unitbar17:SetVisible(false)
		end
	else
		self.unitbar17:SetVisible(false)
	end

	if list[18] then
		if display == "Bars" then
			if total and list[18].mode and list[18].mode / total > 0 then
				self.unitbar18:SetText("")
				self.unitbar18:SetVisible(true)
				self.unitbar18:SetFontColor(1, 1, 1, 1)
				self.unitbar18:SetWidth(list[18].mode / total * width)
				self.unitbar18:SetBackgroundColor(colours[18].r, colours[18].g, colours[18].b, alpha)
			else
				self.unitbar18:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar18:SetWidth(width)
			self.unitbar18:SetVisible(true)
			self.unitbar18:SetText(list[18].name)
			self.unitbar18:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar18:SetFontColor(colours[18].r, colours[18].g, colours[18].b, alpha)
		else
			self.unitbar18:SetVisible(false)
		end
	else
		self.unitbar18:SetVisible(false)
	end

	if list[19] then
		if display == "Bars" then
			if total and list[19].mode and list[19].mode / total > 0 then
				self.unitbar19:SetText("")
				self.unitbar19:SetVisible(true)
				self.unitbar19:SetFontColor(1, 1, 1, 1)
				self.unitbar19:SetWidth(list[19].mode / total * width)
				self.unitbar19:SetBackgroundColor(colours[19].r, colours[19].g, colours[19].b, alpha)
			else
				self.unitbar19:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar19:SetWidth(width)
			self.unitbar19:SetVisible(true)
			self.unitbar19:SetText(list[19].name)
			self.unitbar19:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar19:SetFontColor(colours[19].r, colours[19].g, colours[19].b, alpha)
		else
			self.unitbar19:SetVisible(false)
		end
	else
		self.unitbar19:SetVisible(false)
	end

	if list[20] then
		if display == "Bars" then
			if total and list[20].mode and list[20].mode / total > 0 then
				self.unitbar20:SetText("")
				self.unitbar20:SetVisible(true)
				self.unitbar20:SetFontColor(1, 1, 1, 1)
				self.unitbar20:SetWidth(list[20].mode / total * width)
				self.unitbar20:SetBackgroundColor(colours[20].r, colours[20].g, colours[20].b, alpha)
			else
				self.unitbar20:SetVisible(false)
			end
		elseif display == "Calling" then
			self.unitbar20:SetWidth(width)
			self.unitbar20:SetVisible(true)
			self.unitbar20:SetText(list[20].name)
			self.unitbar20:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar20:SetFontColor(colours[20].r, colours[20].g, colours[20].b, alpha)
		else
			self.unitbar20:SetVisible(false)
		end
	else
		self.unitbar20:SetVisible(false)
	end
end

function Interface:CombatTotal(text1, text2)
	if self.state.mouseDown1 then return end

	local total1 = SuperMeter.Number(text1)
	local total2 = SuperMeter.Number(text2)

	if text1 > 0 or text2 > 0 then
		self.totaltext2:SetText(total1)
		self.totaltext3:SetText(total2)
		if not SuperMeter_modeDesc and not SuperMeter_showPlayer and not SuperMeter_minimal then
			self.totaltext1:SetText("Total:")
			SuperMeter_value = true
		end
	else
		if not SuperMeter_modeDesc then
			SuperMeter_value = nil
			self:ResetText()
		end
	end
end

function Interface:LoggerText(text)
	self.plog:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_logX, SuperMeter_logY)
	self.plogtitlebg:SetWidth(670.8)
	self.plogoutbg:SetWidth(670.8)
	self.plogmask:SetWidth(670.8)
	self.plog:SetWidth(680.8)

	self.plogtext:SetText(text)

	local difference = ((self.plogtext:GetWidth() + 34) - self.plogmask:GetWidth()) / 2
	local doHeight = self.plogtext:GetHeight()
	local dmHeight = self.plogmask:GetHeight()

	if doHeight > dmHeight then
		self.plogslider:SetRange(0, doHeight - dmHeight - 6)
		self.plogslider:SetVisible(true)
		self.plogslider:Nudge(doHeight)
	else
		self.plogtext:SetPoint("TOPLEFT", self.plogmask, "TOPLEFT", 40, -2.8)
		self.plogslider:SetVisible(false)
		self.plogslider:SetRange(0, 0)
	end

	if difference > 0 then
		self.plog:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_logX - difference, SuperMeter_logY)
		self.plogtitlebg:SetWidth(self.plogtext:GetWidth() + 40)
		self.plogoutbg:SetWidth(self.plogtext:GetWidth() + 40)
		self.plogmask:SetWidth(self.plogtext:GetWidth() + 40)
		self.plog:SetWidth(self.plogtext:GetWidth() + 48)
	end
end

function Interface:LoggerTitle(text)
	self.plogtitle2:SetText(text)
end

function Interface:LoggerReset()
	self.plog:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_logX, SuperMeter_logY)
	self.plog:SetVisible(false)
end

function Interface:GetEntry(table)
	local height = self.plogtext:GetHeight()
	local top = self.plogtext:GetTop()
	local mouse = Inspect.Mouse()

	local interval = mouse.y - top
	local entry = false

	if table and table[1] then
		local max = height / #table
		self.copy:SetKeyFocus(false)
		for i = 1, interval / max do
			entry = table[i+1]
		end
		if not entry then
			entry = table[1]
		end
	end

	if entry then
		self.copy:SetText(entry)
		self.copy:SetKeyFocus(true)
		self.copy:SetVisible(not self.copy:GetVisible())
		self.totaltext1:SetVisible(not self.copy:GetVisible())
	end
end

function Interface:ManagerSessions(set1, set2)
	if SuperMeter_inCombat then self.smgrm:SetVisible(false) return end

	local text1 = ""
	local text2 = ""
	local setText1 = ""
	local setText2 = ""

	for k,v in pairs (SuperMeter.State.sessions) do
		local name = false
		
		if not name and v.enemies then
			for k,v in pairs (v.enemies) do
				if k == 1 and v.name then
					name = v.name
				end
			end
		end
		
		if not name and v.allies then
			for k,v in pairs (v.allies) do
				if k == 1 and v.name then
					name = v.name
				end
			end
		end
		
		if not name then
			name = "Empty Session"
		end
		
		text1 = text1 .. "[ " .. tostring(k) .. " ][ " .. SuperMeter.Time(v.combatTime) .. " ] " .. name .. "\n"
		
		if set1 and v == SuperMeter_currentSelected then
			setText1 = "[ " .. tostring(k) .. " ][ " .. SuperMeter.Time(v.combatTime) .. " ] " .. name
		end
	end

	for k,v in pairs (SuperMeter_export) do
		local name = false
		
		if not name and v.enemies then
			for k,v in pairs (v.enemies) do
				if k == 1 and v.name then
					name = v.name
				end
			end
		end
		
		if not name and v.allies then
			for k,v in pairs (v.allies) do
				if k == 1 and v.name then
					name = v.name
				end
			end
		end
		
		if not name then
			name = "Empty Session"
		end
		
		text2 = text2 .. "[ " .. tostring(k) .. " ][ " .. SuperMeter.Time(v.combatTime) .. " ] " .. name .. "\n"
		
		if set2 and v == SuperMeter_savedSelected then
			setText2 = "[ " .. tostring(k) .. " ][ " .. SuperMeter.Time(v.combatTime) .. " ] " .. name
		end
	end

	if set1 then
		self.smgrct:SetText(setText1)
	end

	if set2 then
		self.smgrst:SetText(setText2)
	end

	if not set1 and not set2 then
		self.smgrt:SetText("Super Meter Session Manager")
		self.smgrct:SetText(" Current Sessions")
		self.smgrst:SetText(" Saved Sessions")
		self.smgri:SetText("Export/Import")
		self.smgrv:SetText("View Session")
		self.smgrd:SetText("Delete")
		self.smgrc:SetText(text1)
		self.smgrs:SetText(text2)
	end

	if self.smgrcm:GetHeight() < self.smgrc:GetHeight() then
		self.smgrcs:SetRange(0, self.smgrc:GetHeight() - self.smgrcm:GetHeight())
		self.smgrcs:SetVisible(true)
	else
		self.smgrcs:SetVisible(false)
	end

	if self.smgrsm:GetHeight() < self.smgrs:GetHeight() then
		self.smgrss:SetRange(0, self.smgrs:GetHeight() - self.smgrsm:GetHeight())
		self.smgrss:SetVisible(true)
	else
		self.smgrss:SetVisible(false)
	end
end

function Interface:GetSession(current, saved)
	local mouse = Inspect.Mouse()
	local top1 = self.smgrc:GetTop()
	local top2 = self.smgrs:GetTop()
	local interval1 = mouse.y - 2 - top1
	local interval2 = mouse.y - 2 - top2

	local session1 = false
	local session2 = false
	local max1 = 22
	local max2 = 22

	if current then
		if #SuperMeter.State.sessions > 0 then
			max1 = self.smgrc:GetHeight() / #SuperMeter.State.sessions
		end
		for i = 1, interval1 / max1 do
			session1 = SuperMeter.State.sessions[i+1]
		end
		if not session1 then
			session1 = SuperMeter.State.sessions[1]
		end
	end

	if saved then
		if #SuperMeter_export > 0 then
			max2 = self.smgrs:GetHeight() / #SuperMeter_export
		end
		for i = 1, interval2 / max2 do
			session2 = SuperMeter_export[i+1]
		end
		if not session2 then
			session2 = SuperMeter_export[1]
		end
	end

	if SuperMeter_currentSelected == session1 then
		self.smgrct:SetText(" Current Sessions")
		SuperMeter_currentSelected = nil
		current = nil
	end

	if SuperMeter_savedSelected == session2 then
		self.smgrst:SetText(" Saved Sessions")
		SuperMeter_savedSelected = nil
		saved = nil
	end

	if not SuperMeter_currentSelected and not SuperMeter_savedSelected then
		self.smgri:SetEnabled(false)
		self.smgrv:SetEnabled(false)
		self.smgrd:SetEnabled(false)
	end

	if current then
		SuperMeter_currentSelected = session1
		self:ManagerSessions(true)
	end

	if saved then
		SuperMeter_savedSelected = session2
		self:ManagerSessions(nil, true)
	end

	if saved or current then
		self.smgri:SetEnabled(true)
		self.smgrd:SetEnabled(true)
	end
end

function Interface:ChangeSession()
	if not SuperMeter_showall then
		if SuperMeter.State.sessionIndex <= 0 then
			self.menus3:SetText("00 - 00")
		else
			self.menus3:SetText(string.format("%02d - %02d", SuperMeter.State.sessionIndex - SuperMeter.State.sessionOffset, #SuperMeter.State.sessions))
		end
		self:SortSlots(nil, true)
	end

	if SuperMeter_sticky then
		SuperMeter_sticky = nil
		self.combattext2.Event:MouseOut()
	end

	SuperMeter.Log()
	self:SetTime()
	self:Display()
end

function Interface:AbilitySort(advanced)
	local session = SuperMeter.Session()
	local mode = SuperMeter_ModeRequest
	local font = SuperMeter_fontSize
	local time = session.combatTime
	local unit = self:GetUnit(true)

	local data1 = ""
	local info1 = ""
	local data2 = ""
	local info2 = ""

	local title1 = ""
	local title2 = ""
	local aTitle1 = ""
	local aTitle2 = ""

	local abilityName = false
	local run = false
	local total = 0

	if SuperMeter_abilityMode == mode then
		SuperMeter_abilityMode = mode
	else
		SuperMeter_abilityUnit = nil
	end

	for k,v in pairs (session.units) do
		if unit and unit.name == session.units[k].name then
			if unit == SuperMeter_abilityUnit and not advanced then return end
			
			local unit = session.units[k]
			local abilities = {}
			local calling = ""
			local list = {}
			
			if unit.level == "??" then 
				calling = "(Boss) "
			elseif unit.calling == "cleric" then
				calling = "(Cleric) "
			elseif unit.calling == "mage" then
				calling = "(Mage) "
			elseif unit.calling == "rogue" then
				calling = "(Rogue) "
			elseif unit.calling == "warrior" then
				calling = "(Warrior) "
			end
			
			if SuperMeter_side == "Allies" then
				list = session.allies
			else
				list = session.enemies
			end
			
			for k,v in pairs (list) do
				if unit.name == v.name then
					if mode == SuperMeter_mode1 and v.mode1 > 0 then
						total = v.mode1
					elseif mode == SuperMeter_mode2 and v.mode2 > 0 then
						total = v.mode2
					end
				end
			end
			
			if mode == "DPS" then
				total = unit.damage
			elseif mode == "HPS" then
				total = unit.healing
			elseif mode == "OPS" then
				total = unit.overHealing
			end
			
			if total <= 0 then self:InfotipHide() self:DatatipHide() return end
			
			if unit.name then
				title1 = unit.name .. "'s " .. calling .. "Ability Data:\n\n"
				title2 = unit.name .. "'s " .. calling .. "Combat Data:\n\n"
				aTitle1 = unit.name .. "'s " .. calling .. "Critical Breakdown:\n\n"
				aTitle2 = unit.name .. "'s " .. calling .. "Ability Breakdown:\n\n"
			end
			
			local NoNan = 00.00000000000000000002
			local DTotal = (unit.damageCritical / (unit.damageOut - unit.damageNonCritical + NoNan)) * 100
			local HTotal = (unit.healingCritical / (unit.healingOut - unit.healingNonCritical + NoNan)) * 100
			local OHTotal = (unit.overHealingCritical / (unit.overHealingOut - unit.overhealingNonCritical + NoNan)) * 100
			local OKTotal = (unit.overKillCritical / (unit.overKillOut - unit.overKillNonCritical + NoNan)) * 100
			local DTTotal = (unit.damageTakenCritical / (unit.damageIn - unit.damageTakenNonCritical + NoNan)) * 100
			local HTTotal = (unit.healingTakenCritical / (unit.healingIn - unit.healingTakenNonCritical + NoNan)) * 100
			local DABTotal = (unit.damageAbsorbIn / (unit.damageIn + NoNan)) * 100
			local DAVTotal = (unit.damageAvoided / (unit.damageAvoidIn + NoNan)) * 100
			local DBTotal = (unit.damageBlockIn / (unit.damageMitigable + NoNan)) * 100
			local DDTotal = (unit.damageDeflectIn / (unit.damageMitigable + NoNan)) * 100
			local DMTotal = (unit.damageMissed / (unit.damageOut + NoNan)) * 100
			
			for k,v in pairs(unit.abilities) do
				table.insert(abilities, k)
				abilityName = v.ability
			end
			
			if not abilityName then return end
			
			if mode == "DPS" or mode == "DMG" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damage.value > unit.abilities[b].damage.value end)
			elseif mode == "HPS" or mode == "HLG" then
				table.sort(abilities, function(a, b) return unit.abilities[a].healing.value > unit.abilities[b].healing.value end)
			elseif mode == "OPS" or mode == "OHG" then
				table.sort(abilities, function(a, b) return unit.abilities[a].overHealing.value > unit.abilities[b].overHealing.value end)
			elseif mode == "OKL" then
				table.sort(abilities, function(a, b) return unit.abilities[a].overKill.value > unit.abilities[b].overKill.value end)
			elseif mode == "DTN" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageTaken.value > unit.abilities[b].damageTaken.value end)
			elseif mode == "HTN" then
				table.sort(abilities, function(a, b) return unit.abilities[a].healingTaken.value > unit.abilities[b].healingTaken.value end)
			elseif mode == "ASB" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageAbsorbed.value > unit.abilities[b].damageAbsorbed.value end)
			elseif mode == "AVD" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageAvoided.value > unit.abilities[b].damageAvoided.value end)
			elseif mode == "BLK" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageBlocked.value > unit.abilities[b].damageBlocked.value end)
			elseif mode == "DFT" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageDeflected.value > unit.abilities[b].damageDeflected.value end)
			elseif mode == "MSD" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageMissed.value > unit.abilities[b].damageMissed.value end)
			end
			
			if #abilities > 28 then
				for i = 29, #abilities do
					abilities[i] = nil
				end
			end
			
			for k,v in pairs(abilities) do
				local ability = unit.abilities[v]
				local name = unit.abilities[v].ability.name
				
				local count = 0
				local critCount = 0
				local critMax = 0
				local critMin = 0
				local max = 0
				local min = 0
				local value = 0
				
				if mode == "DPS" or mode == "DMG" then
					if name and not Damage[name] then
						data1 = unit.damageOut .. " Attacks " .. unit.damageCritical .. " Criticals: " .. string.format("%.2f%%\n", DTotal)
						count = ability.damage.count
						critCount = ability.damage.critCount
						critMax = ability.damage.critMax
						critMin = ability.damage.critMin
						max = ability.damage.max
						min = ability.damage.min
						value = ability.damage.value
					end
				elseif mode == "HPS" or mode == "HLG" then
					if name and not Healing[name] then
						data1 = unit.healingOut .. " Heals " .. unit.healingCritical .. " Criticals: " .. string.format("%.2f%%\n", HTotal)
						count = ability.healing.count
						critCount = ability.healing.critCount
						critMax = ability.healing.critMax
						critMin = ability.healing.critMin
						max = ability.healing.max
						min = ability.healing.min
						value = ability.healing.value
					end
				elseif mode == "OPS" or mode == "OHG" then
					if name and not OverHealing[name] then
						data1 = unit.overHealingOut .. " Heals " .. unit.overHealingCritical .. " Criticals: " .. string.format("%.2f%%\n", OHTotal)
						count = ability.overHealing.count
						critCount = ability.overHealing.critCount
						critMax = ability.overHealing.critMax
						critMin = ability.overHealing.critMin
						max = ability.overHealing.max
						min = ability.overHealing.min
						value = ability.overHealing.value
					end
				elseif mode == "OKL" then
					if name and not OverKill[name] then
						data1 = unit.overKillOut .. " Attacks " .. unit.overKillCritical .. " Criticals: " .. string.format("%.2f%%\n", OKTotal)
						count = ability.overKill.count
						critCount = ability.overKill.critCount
						critMax = ability.overKill.critMax
						critMin = ability.overKill.critMin
						max = ability.overKill.max
						min = ability.overKill.min
						value = ability.overKill.value
					end
				elseif mode == "DTN" then
					if name and not DamageTaken[name] then
						data1 = unit.damageIn .. " Attacks " .. unit.damageTakenCritical .. " Criticals: " .. string.format("%.2f%%\n", DTTotal)
						count = ability.damageTaken.count
						critCount = ability.damageTaken.critCount
						critMax = ability.damageTaken.critMax
						critMin = ability.damageTaken.critMin
						max = ability.damageTaken.max
						min = ability.damageTaken.min
						value = ability.damageTaken.value
					end
				elseif mode == "HTN" then
					if name and not HealingTaken[name] then
						data1 = unit.healingIn .. " Heals " .. unit.healingTakenCritical .. " Criticals: " .. string.format("%.2f%%\n", HTTotal)
						count = ability.healingTaken.count
						critCount = ability.healingTaken.critCount
						critMax = ability.healingTaken.critMax
						critMin = ability.healingTaken.critMin
						max = ability.healingTaken.max
						min = ability.healingTaken.min
						value = ability.healingTaken.value
					end
				elseif mode == "ASB" then
					if name and not DamageAbsorbed[name] then
						data1 = unit.damageIn .. " Attacks " .. unit.damageAbsorbIn .. " Absorbed: " .. string.format("%.2f%%\n", DABTotal)
						count = ability.damageAbsorbed.count
						critCount = ability.damageAbsorbed.critCount
						critMax = ability.damageAbsorbed.critMax
						critMin = ability.damageAbsorbed.critMin
						max = ability.damageAbsorbed.max
						min = ability.damageAbsorbed.min
						value = ability.damageAbsorbed.value
					end
				elseif mode == "AVD" then
					if name and not DamageAvoided[name] then
						data1 = unit.damageAvoidIn .. " Avoidable " .. unit.damageAvoided .. " Avoided: " .. string.format("%.2f%%\n", DAVTotal)
						count = ability.damageAvoided.count
						critCount = ability.damageAvoided.critCount
						critMax = ability.damageAvoided.critMax
						critMin = ability.damageAvoided.critMin
						max = ability.damageAvoided.max
						min = ability.damageAvoided.min
						value = ability.damageAvoided.value
					end
				elseif mode == "BLK" then
					if name and not DamageBlocked[name] then
						data1 = unit.damageMitigable .. " Blockable " .. unit.damageBlockIn .. " Blocked: " .. string.format("%.2f%%\n", DBTotal)
						count = ability.damageBlocked.count
						critCount = ability.damageBlocked.critCount
						critMax = ability.damageBlocked.critMax
						critMin = ability.damageBlocked.critMin
						max = ability.damageBlocked.max
						min = ability.damageBlocked.min
						value = ability.damageBlocked.value
					end
				elseif mode == "DFT" then
					if name and not DamageDeflected[name] then
						data1 = unit.damageMitigable .. " Deflectable " .. unit.damageDeflectIn .. " Deflected: " .. string.format("%.2f%%\n", DDTotal)
						count = ability.damageDeflected.count
						critCount = ability.damageDeflected.critCount
						critMax = ability.damageDeflected.critMax
						critMin = ability.damageDeflected.critMin
						max = ability.damageDeflected.max
						min = ability.damageDeflected.min
						value = ability.damageDeflected.value
					end
				elseif mode == "MSD" then
					if name and not DamageMissed[name] then
						data1 = unit.damageOut .. " Attacks " .. unit.damageMissed .. " Missed: " .. string.format("%.2f%%\n", DMTotal)
						count = ability.damageMissed.count
						critCount = ability.damageMissed.critCount
						critMax = ability.damageMissed.critMax
						critMin = ability.damageMissed.critMin
						max = ability.damageMissed.max
						min = ability.damageMissed.min
						value = ability.damageMissed.value
					end
				end
				
				if advanced and value > 0 then
					local average = (max + min) / 2
					local critAverage = (critMax + critMin) / 2
					
					if mode == "DPS" or mode == "HPS" or mode == "OPS" then
						critMin = string.format("%.0f", critMin / time)
						critMax = string.format("%.0f", critMax / time)
						min = string.format("%.0f", min / time)
						max = string.format("%.0f", max / time)
						critAverage = critAverage / time
						average = average / time
					end
					
					if font == 13 then
						data2 = data2 .. string.format("MAX:  %-14s\tAVG:  %-14s\tMIN:  %-14s\tCOUNT:  %-016s\t%-0s\n", max, string.format("%.0f", average), min, count, v)
						info2 = info2 .. string.format("MAX:  %-14s\tAVG:  %-14s\tMIN:  %-14s\tCOUNT:  %-016s\t%-0s\n", critMax, string.format("%.0f", critAverage), critMin, critCount, v)
					else
						data2 = data2 .. string.format("MAX:  %-012s\tAVG:  %-012s\tMIN:  %-012s\tCOUNT:  %-014s\t%-0s\n", max, string.format("%.0f", average), min, count, v)
						info2 = info2 .. string.format("MAX:  %-012s\tAVG:  %-012s\tMIN:  %-012s\tCOUNT:  %-014s\t%-0s\n", critMax, string.format("%.0f", critAverage), critMin, critCount, v)
					end
					
					run = true
				end
				
				if not advanced and value > 0 then
					local abilityValue = value
					
					if mode == "DPS" or mode == "HPS" or mode == "OPS" then
						abilityValue = SuperMeter.Number(value / time)
					end
					
					info1 = info1 .. "[ " .. abilityValue .. " ] [ " .. string.format("%.2f%%", (value / total) * 100) .. " ]  " .. v .. " \n"
					
					run = true
				end
			end
			SuperMeter_ModeRequest = nil
		end
	end

	if SuperMeter_sticky then
		SuperMeter_sticky = nil
	end

	if not advanced and run then
		self:InfotipShow(title1 .. info1)
		self:DatatipShow(title2 .. data1)
	end

	if advanced and run then
		self:InfotipShow(aTitle1 .. info2, true)
		self:DatatipShow(aTitle2 .. data2, true)
	end

	SuperMeter_abilityMode = mode
	SuperMeter_abilityUnit = unit
end

function Interface:DataSort()
	if not SuperMeter_enabled then return end

	local session = SuperMeter.Session()
	local player = SuperMeter.Player
	local time = session.combatTime
	local mode1 = SuperMeter_mode1
	local mode2 = SuperMeter_mode2
	local mode = SuperMeter_mode

	session.allies = {}
	session.enemies = {}

	for k,v in pairs (session.units) do
		local unit = session.units[k]
		
		if SuperMeter_maxSlots == 5.02 then
			if unit.name == player.name or not unit.player then
				unit = session.units[k]
			else
				unit = nil
			end
		end
		
		if unit and unit.name then
			local data = {
				calling = unit.calling,
				level = unit.level,
				name = unit.name,
				mode1 = 0,
				mode2 = 0,
				mode = 0,
			}
			
			if mode1 == "DPS" then
				data.mode1 = unit.damage / time
			elseif mode1 == "DMG" then
				data.mode1 = unit.damage
			elseif mode1 == "HPS" then
				data.mode1 = unit.healing / time
			elseif mode1 == "HLG" then
				data.mode1 = unit.healing
			elseif mode1 == "OPS" then
				data.mode1 = unit.overHealing / time
			elseif mode1 == "OHG" then
				data.mode1 = unit.overHealing
			elseif mode1 == "OKL" then
				data.mode1 = unit.overKill
			elseif mode1 == "DTN" then
				data.mode1 = unit.damageTaken
			elseif mode1 == "HTN" then
				data.mode1 = unit.healingTaken
			elseif mode1 == "ASB" then
				data.mode1 = unit.damageAbsorbed
			elseif mode1 == "AVD" then
				data.mode1 = unit.damageAvoided
			elseif mode1 == "BLK" then
				data.mode1 = unit.damageBlocked
			elseif mode1 == "DFT" then
				data.mode1 = unit.damageDeflected
			elseif mode1 == "MSD" then
				data.mode1 = unit.damageMissed
			end
			
			if mode2 == "DPS" then
				data.mode2 = unit.damage / time
			elseif mode2 == "DMG" then
				data.mode2 = unit.damage
			elseif mode2 == "HPS" then
				data.mode2 = unit.healing / time
			elseif mode2 == "HLG" then
				data.mode2 = unit.healing
			elseif mode2 == "OPS" then
				data.mode2 = unit.overHealing / time
			elseif mode2 == "OHG" then
				data.mode2 = unit.overHealing
			elseif mode2 == "OKL" then
				data.mode2 = unit.overKill
			elseif mode2 == "DTN" then
				data.mode2 = unit.damageTaken
			elseif mode2 == "HTN" then
				data.mode2 = unit.healingTaken
			elseif mode2 == "ASB" then
				data.mode2 = unit.damageAbsorbed
			elseif mode2 == "AVD" then
				data.mode2 = unit.damageAvoided
			elseif mode2 == "BLK" then
				data.mode2 = unit.damageBlocked
			elseif mode2 == "DFT" then
				data.mode2 = unit.damageDeflected
			elseif mode2 == "MSD" then
				data.mode2 = unit.damageMissed
			end
			
			if mode == mode1 then
				data.mode = data.mode1
			elseif mode == mode2 then
				data.mode = data.mode2
			end
			
			if unit.relation == "friendly" then
				if unit.player and data.name then
					table.insert(session.allies, data)
				end
			else
				if unit.name and data.name then
					table.insert(session.enemies, data)
				end
			end
		end
	end

	if mode == mode1 then
		table.sort(session.allies, function (a,b) return a.mode1 > b.mode1 end)
		table.sort(session.enemies, function (a,b) return a.mode1 > b.mode1 end)
	end

	if mode == mode2 then
		table.sort(session.allies, function (a,b) return a.mode2 > b.mode2 end)
		table.sort(session.enemies, function (a,b) return a.mode2 > b.mode2 end)
	end

	if #session.allies > 20 then
		for i = 21, #session.allies do
			session.allies[i] = nil
		end
	end

	if #session.enemies > 20 then
		for i = 21, #session.enemies do
			session.enemies[i] = nil
		end
	end
end

function Interface:FrameSort(export, export1, export2)
	if not SuperMeter_enabled then return end

	local session = SuperMeter.Session()
	local player = SuperMeter.Player
	local mode1 = SuperMeter_mode1
	local mode2 = SuperMeter_mode2

	local list = {}
	local total1 = 0
	local total2 = 0
	local nameText = ""
	local mode1Text = ""
	local mode2Text = ""
	local exportText1 = ""
	local exportText2 = ""

	if SuperMeter_side == "Allies" then
		list = session.allies
	else
		list = session.enemies
	end

	for k,v in pairs (list) do
		local data1 = v.mode1
		local data2 = v.mode2
		local name = v.name
		
		if SuperMeter_showPlayer then
			if name == player.name then
				self.totaltext1:SetText(player.name)
				total1 = data1
				total2 = data2
			end
		else
			total1 = total1 + data1
			total2 = total2 + data2
		end
		
		if name then
			nameText = nameText .. name .. "\n"
			mode1Text = mode1Text .. SuperMeter.Number(data1) .. "\n"
			mode2Text = mode2Text .. SuperMeter.Number(data2) .. "\n"
		end
		
		if export and name then
			local time = SuperMeter.Time(session.combatTime)
			local width = exportText1:len()
			if export1 and data1 and width <= 148 then
				exportText1 = exportText1 .. "  " .. name .. ": " .. SuperMeter.Number(data1)
				self.copy:SetText(SuperMeter_side .. " " .. mode1 .. " " .. time .. exportText1)
			end
			if export2 and data2 and width <= 148 then
				exportText2 = exportText2 .. "  " .. name .. ": " .. SuperMeter.Number(data2)
				self.copy:SetText(SuperMeter_side .. " " .. mode2 .. " " .. time .. exportText2)
			end
			self.copy:SetKeyFocus(false)
			self.copy:SetKeyFocus(true)
		end
	end

	self:CombatTotal(total1, total2)
	self:CombatText(nameText, mode1Text, mode2Text)
end

function Interface:GetUnit(runFunction)
	local session = SuperMeter.Session()
	local top = self.combattext1:GetTop()
	local max = SuperMeter_interval
	local mouse = Inspect.Mouse()

	local interval = mouse.y - 2 - top
	local unit = false
	local list = {}

	if runFunction then
		if SuperMeter_side == "Allies" then
			list = session.allies
		else
			list = session.enemies
		end
		
		if list and list[1] then
			for i = 1, interval / max do
				unit = list[i+1]
			end
			if not unit then
				unit = list[1]
			end
		end
		
		for k,v in pairs (session.units) do
			if unit and unit.name and unit.name == session.units[k].name then
				return session.units[k]
			end
		end
	end
end

function Interface:Update()
	self:DataSort()
	self:FrameSort()
end

function Interface:TipColours(mouseIn)
	if SuperMeter_sticky then return end

	if mouseIn then
		if SuperMeter_side == "Allies" then
			self.tipbg:SetBackgroundColor(0, 0.48, 0, 2)
		else
			self.tipbg:SetBackgroundColor(0.48, 0, 0, 2)
		end
	else
		self.tipbg:SetBackgroundColor(0, 0.48, 0.88, 2)
	end
end

function Interface:InfotipShow(text, advanced)
	if SuperMeter_sticky then return end

	if text then
		self.infotiptext:SetText(text)
		self.infotip:SetHeight(self.infotiptext:GetHeight() + 10)
		self.infotip:SetWidth(self.infotiptext:GetWidth() + 16)
		self.tipbg:SetWidth(self.infotip:GetWidth() + 2)
		
		if (self.infotiptext:GetWidth() + 16) < (SuperMeter_width - 2) then
			self.infotip:SetWidth(SuperMeter_width - 2)
		end
		
		if advanced then
			self.infotip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -0.48, -60)
			self.tipbg:SetWidth(self.infotip:GetWidth() + (self.datatip:GetWidth() * 2) + 4)
			self.tipbg:SetHeight(self.infotip:GetHeight() + 1.8)
		else
			self.infotip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -0.48, -60)
			self.tipbg:SetWidth(self.infotip:GetWidth() + 2)
			
			if self.datatip:GetVisible() then
				self.tipbg:SetHeight(self.infotip:GetHeight() + self.datatip:GetHeight() + 2.8)
			else
				self.tipbg:SetHeight(self.infotip:GetHeight() + 1.8)
			end
		end
		
		self.infotiptext:SetVisible(true)
		self.infotip:SetVisible(true)
		self.tipbg:SetVisible(true)
	end
end

function Interface:InfotipHide()
	if SuperMeter_sticky then return end

	self.tipbg:SetVisible(false)
	SuperMeter_abilityUnit = nil
	self.infotip:SetVisible(false)
	self.infotiptext:SetVisible(false)
end

function Interface:DatatipShow(text, advanced)
	if SuperMeter_sticky then return end

	if text then
		self.datatiptext:SetText(text)
		self.datatip:SetWidth(self.infotip:GetWidth())
		self.datatip:SetHeight(self.datatiptext:GetHeight() + 10)
		
		if self.datatiptext:GetWidth() > self.infotiptext:GetWidth() then
			self.infotip:SetWidth(self.datatiptext:GetWidth() + 22)
			self.datatip:SetWidth(self.infotip:GetWidth())
		end
		
		if advanced then
			self.datatip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -self.infotip:GetWidth() - 2, -60)
			self.tipbg:SetWidth(self.infotip:GetWidth() + (self.datatip:GetWidth() * 2) + 4)
			self.tipbg:SetHeight(self.infotip:GetHeight() + 1.8)
		else
			self.datatip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -0.48, -self.infotip:GetHeight() -60.8)
			self.tipbg:SetWidth(self.infotip:GetWidth() + 2)
			
			if self.infotip:GetVisible() then
				self.tipbg:SetHeight(self.infotip:GetHeight() + self.datatip:GetHeight() + 2.8)
			else
				self.tipbg:SetHeight(self.infotip:GetHeight() + 1.8)
			end
		end
		
		self.datatiptext:SetVisible(true)
		self.datatip:SetVisible(true)
		self.tipbg:SetVisible(true)
	end
end

function Interface:DatatipHide()
	if SuperMeter_sticky then return end

	self.tipbg:SetVisible(false)
	SuperMeter_abilityUnit = nil
	self.datatip:SetVisible(false)
	self.datatiptext:SetVisible(false)
end

function SuperMeter.Reset()
	SuperMeter_force = nil
	SuperMeter_ignore = {}
	SuperMeter_combat = {}
	SuperMeter_inCombat = nil
	SuperMeter_bossActive = nil
	SuperMeter.State.sessions = {}
	SuperMeter.State.combatTime = 0
	SuperMeter.State.lastUpdate = 0
	SuperMeter.State.sessionIndex = 0
	SuperMeter.State.sessionOffset = 0
	SuperMeter.UI.Interface:ResetText()
	SuperMeter.UI.Interface:ChangeSession()
end

function Session:New()
	return {allies = {}, combatTime = 0, deathlog = {}, enemies = {}, startCombat = 0, units = {}}
end

function SuperMeter.Session(current)
	if not SuperMeter_enabled then return end

	local offset = SuperMeter.State.sessionIndex - SuperMeter.State.sessionOffset
	local index = SuperMeter.State.sessionIndex

	if current then
		if SuperMeter.State.sessions[index] then
			return SuperMeter.State.sessions[index]
		else
			return Session:New()
		end
	else
		if SuperMeter.State.sessions[offset] then
			return SuperMeter.State.sessions[offset]
		else
			return Session:New()
		end
	end
end

function SuperMeter.Time(time)
	local hour = math.floor(time / 60 / 60)
	local min = math.floor(time / 60) % 60
	local sec = time % 60

	if hour > 0 then
		return string.format("%02d:%02d:%02d", hour, min, sec)
	else
		return string.format("%02d:%02d", min, sec)
	end
end

function SuperMeter.Number(number)
	if number < 10000 then
		return string.format("%d", number)
	elseif number < 100000 then
		return string.format("%4.1fk", number / 1000)
	elseif number < 1000000 then
		return string.format("%dk", number / 1000)
	elseif number < 10000000 then
		return string.format("%4.2fm", number / 1000000)
	elseif number < 100000000 then
		return string.format("%4.1fm", number / 1000000)
	else
		return string.format("%dm", number / 1000000)
	end
end