----------------------------------------------------------------------------
------------------------ Super Meter - Addon Loader ------------------------
----------------------------------------------------------------------------

function SuperMeter.Loader(addon)
	if SuperMeter_running then return end

	if addon == "SuperMeter" then
		SuperMeter.Player = Inspect.Unit.Detail("player")
		SuperMeter.UI.Interface = Interface:New()
		SuperMeter.UI.Interface:Display(true)
		SuperMeter.UI.Interface:Relation()
		SuperMeter_running = true
		Interface = {}
	end
end

function SuperMeter.Command(args)
	if args == "alpha" then
		if SuperMeter_alpha == 0.8 then
			SuperMeter_alpha = 0.688
		else
			SuperMeter_alpha = 0.8
		end
		SuperMeter.UI.Interface:Display()
		return
	elseif args == "converter" then
		if SuperMeter_converter then
			print(SuperMeter_region3)
		else
			print(SuperMeter_region4)
		end
		SuperMeter_converter = not SuperMeter_converter
		return
	elseif args == "group" then
		if SuperMeter_group then
			print(SuperMeter_region5)
		else
			print(SuperMeter_region6)
		end
		SuperMeter_group = not SuperMeter_group
		return
	elseif args == "help" then 
		SuperMeter.Help()
		return
	elseif args == "log" then
		if SuperMeter_logEnabled then
			print(SuperMeter_region7)
		else
			print(SuperMeter_region8)
		end
		SuperMeter_logEnabled = not SuperMeter_logEnabled
		SuperMeter.UI.Interface:Display()
		return
	elseif args == "performance" then 
		if SuperMeter_performance then
			SuperMeter_minimal = false
			SuperMeter_converter = true
			SuperMeter_logEnabled = true
			SuperMeter_display = "Calling"
			print(SuperMeter_region9)
		else
			SuperMeter_maxSlots = 5
			SuperMeter_minimal = true
			SuperMeter_display = "None"
			SuperMeter_converter = false
			SuperMeter_logEnabled = false
			print(SuperMeter_region10)
		end
		SuperMeter.UI.Interface:Display()
		SuperMeter.UI.Interface:SortSlots()
		SuperMeter_performance = not SuperMeter_performance
		return
	elseif args == "reset" then
		SuperMeter_alpha = 0.8
		SuperMeter_converter = true
		SuperMeter_display = "Calling"
		SuperMeter_enabled = true
		SuperMeter_fontSize = 14
		SuperMeter_group = true
		SuperMeter_growUp = false
		SuperMeter_logEnabled = true
		SuperMeter_logX = 620
		SuperMeter_logY = 748
		SuperMeter_maxSlots = 10
		SuperMeter_menuX = 0
		SuperMeter_menuY = 0
		SuperMeter_minimal = false
		SuperMeter_mode = "DPS"
		SuperMeter_mode1 = "DPS"
		SuperMeter_mode2 = "HPS"
		SuperMeter_performance = false
		SuperMeter_self = true
		SuperMeter_side = "Allies"
		SuperMeter_tipclick = false
		SuperMeter_width = 268
		SuperMeter_x = 820
		SuperMeter_y = 600
		SuperMeter.Reset()
		SuperMeter.UI.Interface:LoggerReset()
		SuperMeter.UI.Interface:Display(true)
		return
	elseif args == "self" then
		if SuperMeter_self then
			print(SuperMeter_region11)
		else
			print(SuperMeter_region12)
		end
		SuperMeter_self = not SuperMeter_self
		SuperMeter.UI.Interface:Display()
		return
	elseif args == "switch" then
		SuperMeter_enabled = not SuperMeter_enabled
		SuperMeter.UI.Interface:Display(true)
		SuperMeter.UI.Interface:Update()
		SuperMeter.UI.Interface:Toggle()
		SuperMeter.Reset()
		return
	elseif args == "tipclick" then
		if SuperMeter_tipclick then
			print(SuperMeter_region13)
		else
			print(SuperMeter_region14)
		end
		SuperMeter_sticky = nil
		SuperMeter_tipclick = not SuperMeter_tipclick
		return
	elseif args == "toggle" then
		SuperMeter.UI.Interface:Toggle()
		return
	end

	print("Super Meter Commands:")
	print("/sm alpha - Changes the alpha of the main window")
	print("/sm converter - To disable/enable the absorb converter")
	print("/sm group - To disable/enable the group combat detector")
	print("/sm help - To open the help file")
	print("/sm log - To disable/enable the player session logs")
	print("/sm performance - To toggle performance mode")
	print("/sm reset - Resets Super Meter to its default settings")
	print("/sm self - To disable/enable self colour coded blue")
	print("/sm switch - To disable/enable Super Meter")
	print("/sm tipclick - Toggles the left click or mouse over tooltip display")
	print("/sm toggle - Toggles the main frame and reduces CPU usage")
end

table.insert(Event.Addon.SavedVariables.Load.End, {SuperMeter.Loader, "SuperMeter", "Addon Loader"})
table.insert(Command.Slash.Register("SM"), {SuperMeter.Command, "SuperMeter", "Slash Command"})