------------------------------------------------------------------------------
------------------------ Super Meter - Region Options ------------------------
------------------------------------------------------------------------------

SuperMeter_region1 = "Grow up mode enabled"
SuperMeter_region2 = "Grow down mode enabled"

SuperMeter_region3 = "Absorb to heal converter disabled"
SuperMeter_region4 = "Absorb to heal converter enabled"

SuperMeter_region5 = "Group combat detector disabled"
SuperMeter_region6 = "Group combat detector enabled"

SuperMeter_region7 = "Player session logs disabled"
SuperMeter_region8 = "Player session logs enabled"

SuperMeter_region9 = "Performance mode disabled"
SuperMeter_region10 = "Performance mode enabled"

SuperMeter_region11 = "Self colour coded blue disabled"
SuperMeter_region12 = "Self colour coded blue enabled"

SuperMeter_region13 = "Tooltip mouse over display enabled"
SuperMeter_region14 = "Tooltip left click display enabled"

SuperMeter_region15 = " is now active starting new session."
SuperMeter_region16 = "Your are PvP flagged, Absorb converter and Player logs disabled."

function SuperMeter.Help()
	print("Super Meter Help File:")
	print("Left click the mode labels to change mode sorting.")
	print("Right click the mode labels to change modes using the mode menu.")
	print("To export left click on the total frame in that mode column.")
	print("To toggle total or group vs self left click the 'Total' frame.")
	print("To toggle minimal frame mode right click the 'Total' frame.")
	print("The session manager can be toggled by right clicking the index or menu.")
	print("To move the session menu left hold any blue corner and drag.")
	print("The menu position can be reset by middle clicking the menu title.")
	print("Left click the units frame to change the units display slot size.")
	print("Right click the units frame to toggle that units combat log.")
	print("Middle click the units frame to change the units display style.")
	print("Left click a unit in any column to see the basic ability breakdown.")
	print("Right click a unit in any column to see the advanced ability breakdown.")
	print("Left and right click ability tooltip commands can be used in combination.")
	print("Tooltips are mode based and ability data changes with the mode you select. ")
	print("Change log targets by selecting a player and left clicking the target title.")
	print("Type /sm to see all commands, All commands can be made into a macro.")
end

function SuperMeter.Tooltip(getMain, getClear, getNew, getForce, getLog, getHelp, getMenus3, getUnit)
	if not SuperMeter_enabled then return end

	if getMain then
		local info1 = tostring(SuperMeter_converter)
		local info2 = tostring(SuperMeter_group)
		local info3 = tostring(SuperMeter_logEnabled)
		if info1 == "true" then info1 = "True" else info1 = "False" end
		if info2 == "true" then info2 = "True" else info2 = "False" end
		if info3 == "true" then info3 = "True" else info3 = "False" end
		local text = "Super Meter v " .. SuperMeter.Version .. " \n\nLeft Hold And Drag To Move\nMiddle Click Toggles Font Size\nRight Click Changes Growth Direction\nMouse Wheel Changes The Frame Size\n\nAbsorb To Heal Converter Enabled: " .. info1 .. "\nGroup Combat Detector Enabled: " .. info2 .. "\nPlayer Session Logs Enabled: " .. info3
		return text
	end

	if getClear then
		local text = "Clear Data\n\nLeft Click To Clear All Collected Data"
		return text
	end

	if getNew then
		local text = "New Session\n\nLeft Click To Start A New Session"
		return text
	end

	if getForce then
		local text = "Force Combat\n\nLeft Click To Force Start Or Stop Combat"
		return text
	end

	if getLog then
		local text = "Player Session Logs\n\nLeft Click To Open The Player Session Logs"
		return text
	end

	if getHelp then
		local text = "Help File\n\nLeft Click To Open The Help File"
		return text
	end

	if getMenus3 then
		local text = "Session Index\n\nUse The < > Arrows To Change The Session"
		if not SuperMeter_inCombat then
			text = "Session Index\n\nLeft Click To Merge All Sessions\nRight Click To Toggle The Session Manager\nUse The < > Arrows To Change The Session"
		end
		return text
	end

	if getUnit then
		local unit = SuperMeter.UI.Interface:GetUnit(true)
		if unit and unit.name and unit.combatlog[1] then
			local text = "Right Click To View " .. unit.name .. "'s Combat Log "
			return text
		end
	end
end

function Interface:ModeShowText()
	local height = self.mode1select:GetHeight() * 14

	self.mode1select:SetText("Damage P/S")
	self.mode2select:SetText("Damage")
	self.mode3select:SetText("Damage Taken")
	self.mode4select:SetText("Overkill")
	self.mode5select:SetText("Healing P/S")
	self.mode6select:SetText("Healing")
	self.mode7select:SetText("Healing Taken")
	self.mode8select:SetText("Overhealing P/S")
	self.mode9select:SetText("Overhealing")
	self.mode10select:SetText("Absorbed Damage")
	self.mode11select:SetText("Avoided Damage")
	self.mode12select:SetText("Blocked Damage")
	self.mode13select:SetText("Deflected Damage")
	self.mode14select:SetText("Missed Damage")

	self.modeselectbg:SetHeight(height + 12)
	self.modeselect:SetHeight(height + 2.6)
end

function Interface:ModeDescription(mode1, mode2)
	if not mode1 and not mode2 then return end

	local Desc = false
	local Mode = false

	if mode1 then
		Mode = SuperMeter_mode1
	end

	if mode2 then
		Mode = SuperMeter_mode2
	end

	if Mode == "DPS" then
		Desc = "Damage P/S"
	elseif Mode == "DMG" then
		Desc = "Damage"
	elseif Mode == "HPS" then
		Desc = "Healing P/S"
	elseif Mode == "HLG" then
		Desc = "Healing"
	elseif Mode == "OPS" then
		Desc = "Overhealing P/S"
	elseif Mode == "OHG" then
		Desc = "Overhealing"
	elseif Mode == "OKL" then
		Desc = "Overkill"
	elseif Mode == "DTN" then
		Desc = "Damage Taken"
	elseif Mode == "HTN" then
		Desc = "Healing Taken"
	elseif Mode == "ASB" then
		Desc = "Absorbed Damage"
	elseif Mode == "AVD" then
		Desc = "Avoided Damage"
	elseif Mode == "BLK" then
		Desc = "Blocked Damage"
	elseif Mode == "DFT" then
		Desc = "Deflected Damage"
	elseif Mode == "MSD" then
		Desc = "Missed Damage"
	end

	if Desc and not SuperMeter_showPlayer then
		self.totaltext1:SetText(Desc)
		SuperMeter_modeDesc = true
	end
end

function Interface:Line(getHeight, getPosition, getChange)
	local display = SuperMeter_display
	local font = SuperMeter_fontSize

	local height = 0
	local position = 0
	local change = 0

	if display == "Bars" then
		if font == 14 then
			height = 15.984
		else
			height = 14.584
		end
		position = 2.60
		change = 4.0180
	else
		if font == 14 then
			height = 19.850
		else
			height = 18.450
		end
		position = 0.1426
		change = 0.1426
	end

	if getHeight then
		return height
	end

	if getPosition then
		return position
	end

	if getChange then
		return change
	end
end