local addon, private = ...
local function GetBuildInfo()
	local _ret = ""

	_ret = "UpgradeMe Version: "..tostring(UM_GLOBAL.AddonData.toc.Version).."\n\n"
	_ret = _ret.."The following builds have been updated: \n\n"
	_ret = _ret.."     Cleric\n"
	_ret = _ret.."          61SENT/10WARD/5PUR - Heals (3/3/2013)\n\n"
	_ret = _ret.."If you used any of these builds in your current weight sets please go to the weight sets tab "
	_ret = _ret.."and update your sets accordingly.  To update a set, just select the outfit you want to update, "
	_ret = _ret.."then select the weight set from the dropdown list, and finally click save outfit.\n\n"
	_ret = _ret.."If you have any questions or concerns, please let me know as I value your feedback.\n\n"
	_ret = _ret.."Thank you for using the addon,\n\n"
	_ret = _ret.."--Gralli@Faeblight"

	return _ret
end

local function BuildConfig(self)
	local iRow = 0
	local iCol = 0
	local pFld = ""
	local lOutfits = {}

	self:SetVisible(false)
	self:SetCloseButtonVisible(true)
	self:SetTitle("UpgradeMe - Config")
	self:SetWidth(600)
	self:SetHeight(700)
	self:SetPoint("TOPCENTER", UIParent, "TOPCENTER")
	self.StatNames = {}
	self.StatWeights1 = {}
	self.StatSlider1 = {}

	self.um_TabView = UI.CreateFrame("SimpleTabView", "um_TabView", self)
	self.um_TabView:SetTabPosition("top")
	--self.um_TabView.Event.TabSelect = function(view, index) um_TabViewChanged(index) end
	self.um_TabView:SetPoint("TOPLEFT", self:GetContent(), "TOPLEFT", 0, 0)
	self.um_TabView:SetPoint("BOTTOMRIGHT", self:GetContent(), "BOTTOMRIGHT", 0, 0)

	self.um_Tab1 = UI.CreateFrame("Frame", "um_Tab1", self.um_TabView)
	self.um_Tab2 = UI.CreateFrame("Frame", "um_Tab2", self.um_TabView)
	--self.um_Tab3 = UI.CreateFrame("Frame", "um_Tab3", self.um_TabView)

	self.um_TabView:AddTab("Info", self.um_Tab1)
	self.um_TabView:AddTab("Weight Sets", self.um_Tab2)
	--self.um_TabView:AddTab("Options", self.um_Tab3)



	--[[
	Weight Sets Config Set up Begin
	]]--
	self.OutfitsLbl = UI.CreateFrame("Text", "configOutfitsLbl", self.um_Tab2)
	self.OutfitsLbl:SetText("Saved Outfits: ")
	self.OutfitsLbl:SetPoint("TOPLEFT", self.um_Tab2, "TOPLEFT", 10, 10)

	self.Outfits = UI.CreateFrame("SimpleSelect", "configOutfits", self.um_Tab2)
	self.Outfits:SetWidth(250)
	self.Outfits.SetBorder(self.Outfits, 1, 0.5, 0.5, 0.5, 1)
	self.Outfits.Event.ItemSelect = self.OutfitSelected
	self.Outfits:SetLayer(999)
	self.Outfits:SetPoint("CENTERLEFT", self.OutfitsLbl, "CENTERRIGHT", 0, 0)

	self.NewOutfitLbl = UI.CreateFrame("Text", "configNewOutfitlbl", self.um_Tab2)
	self.NewOutfitLbl:SetText("Outfit Name: ")
	self.NewOutfitLbl:SetPoint("TOPLEFT", self.OutfitsLbl, "BOTTOMLEFT", 0, 5)

	self.NewOutfit = UI.CreateFrame("RiftTextfield", "configNewOutfit", self.um_Tab2)
	self.NewOutfit:SetBackgroundColor(0.4,0.4,0.4,1)
	Library.LibSimpleWidgets.SetBorder(self.NewOutfit, 1, 0.5, 0.5, 0.5, 1)
	self.NewOutfit:SetWidth(440)
	self.NewOutfit:SetPoint("CENTERLEFT", self.NewOutfitLbl, "CENTERRIGHT", 5, 0)

	self.NewOutfitDescLbl = UI.CreateFrame("Text", "configNewOutfitDesclbl", self.um_Tab2)
	self.NewOutfitDescLbl:SetText("Description: ")
	self.NewOutfitDescLbl:SetPoint("TOPLEFT", self.NewOutfitLbl, "BOTTOMLEFT", 0, 5)

	self.NewOutfitDescription = UI.CreateFrame("RiftTextfield", "configNewOutfitDesc", self.um_Tab2)
	self.NewOutfitDescription:SetBackgroundColor(0.4,0.4,0.4,1)
	Library.LibSimpleWidgets.SetBorder(self.NewOutfitDescription, 1, 0.5, 0.5, 0.5, 1)
	self.NewOutfitDescription:SetWidth(440)
	self.NewOutfitDescription:SetPoint("TOPLEFT", self.NewOutfit, "BOTTOMLEFT", 0, 5)

	self.SavedStatsLbl = UI.CreateFrame("Text", "configSavedStatslbl", self.um_Tab2)
	self.SavedStatsLbl:SetText("Stats Weights: ")
	self.SavedStatsLbl:SetPoint("TOPLEFT", self.NewOutfitDescLbl, "BOTTOMLEFT", 0, 5)

	self.SavedStats = UI.CreateFrame("SimpleSelect", "configSavedSets", self.um_Tab2)
	self.SavedStats:SetWidth(250)
	self.SavedStats.SetBorder(self.SavedStats, 1, 0.5, 0.5, 0.5, 1)
	self.SavedStats.Event.ItemSelect = self.StatSetSelected
	self.SavedStats:SetLayer(998)
	self.SavedStats:SetPoint("TOPLEFT", self.NewOutfitDescription, "BOTTOMLEFT", 0, 5)

	pFld = self.SavedStatsLbl
	for statname, statrec in pairs(self.Datasets.GetStatsInOrder()) do
		_fld = statrec[3]
		self.StatNames[_fld..""] = UI.CreateFrame("Text", "conifg.statlbl".._fld, self.um_Tab2)
		self.StatNames[_fld..""]:SetText(statrec[2])
		self.StatNames[_fld..""]:SetWidth(60)
		self.StatNames[_fld..""]:SetHeight(20)

		self.StatWeights1[_fld..""] = umSlider("config.stattxt"..statrec[2], self.um_Tab2)
		self.StatWeights1[_fld..""]:SetWidth(150)
		self.StatWeights1[_fld..""]:SetRange(0, 10, .001)
		self.StatWeights1[_fld..""]:SetEditable(true)
		self.StatWeights1[_fld..""]:SetPosition(0)

		if iRow == 0 then
			self.StatNames[_fld..""]:SetPoint("TOPLEFT", pFld, "BOTTOMLEFT", iCol+25, 10)
		elseif iRow < 19 then
			self.StatNames[_fld..""]:SetPoint("TOPLEFT", self.StatNames[pFld..""], "BOTTOMLEFT", 0, 5)
		end
		self.StatWeights1[_fld..""]:SetPoint("TOPLEFT",self.StatNames[_fld..""], "TOPRIGHT", 25, 0)

		iRow = iRow + 1
		pFld = _fld
		if iRow == 18 then
			iRow = 0
			pFld = self.SavedStats
			iCol = 180
		end
	end

	self.StartNewOutfit = UI.CreateFrame("Text", "configCancelOutfit", self.um_Tab2)
	self.StartNewOutfit:SetBackgroundColor(0.7,0.7,0.7,1)
	self.StartNewOutfit:SetFontColor(0,0,0,1)
	Library.LibSimpleWidgets.SetBorder(self.StartNewOutfit, 1, 0.5, 0.5, 0.5, 1)
	self.StartNewOutfit:SetText("New Outfit")
	self.StartNewOutfit.Event.LeftClick = function () self:StartNewOutfitClick() end

	self.CreateOutfit = UI.CreateFrame("Text", "configCreateOutfit", self.um_Tab2)
	self.CreateOutfit:SetBackgroundColor(0.7,0.7,0.7,1)
	self.CreateOutfit:SetFontColor(0,0,0,1)
	Library.LibSimpleWidgets.SetBorder(self.CreateOutfit, 1, 0.5, 0.5, 0.5, 1)
	self.CreateOutfit:SetText("Save Outfit")
	self.CreateOutfit.Event.LeftClick = function () self:CreateOutfitClick(self.NewOutfit:GetText(), self.NewOutfitDescription:GetText()) end

	self.DeleteOutfit = UI.CreateFrame("Text", "configDeleteOutfit", self.um_Tab2)
	self.DeleteOutfit:SetBackgroundColor(0.7,0.7,0.7,1)
	self.DeleteOutfit:SetFontColor(0,0,0,1)
	Library.LibSimpleWidgets.SetBorder(self.DeleteOutfit, 1, 0.5, 0.5, 0.5, 1)
	self.DeleteOutfit:SetText("Delete Outfit")
	self.DeleteOutfit.Event.LeftClick = function () self:DeleteOutfitClick() end

	self.CancelOutfit = UI.CreateFrame("Text", "configCancelOutfit", self.um_Tab2)
	self.CancelOutfit:SetBackgroundColor(0.7,0.7,0.7,1)
	self.CancelOutfit:SetFontColor(0,0,0,1)
	Library.LibSimpleWidgets.SetBorder(self.CancelOutfit, 1, 0.5, 0.5, 0.5, 1)
	self.CancelOutfit:SetText("Cancel Changes")
	self.CancelOutfit.Event.LeftClick = function () self:CancelOutfitClick() end

	self.StartNewOutfit:SetPoint("BOTTOMLEFT", self:GetContent(), "BOTTOMLEFT", 10, -10)
	self.CancelOutfit:SetPoint("BOTTOMCENTER", self:GetContent(), "BOTTOMCENTER", 40, -10)
	self.CreateOutfit:SetPoint("TOPRIGHT", self.CancelOutfit, "TOPLEFT", -10, 0)
	self.DeleteOutfit:SetPoint("BOTTOMRIGHT", self:GetContent(), "BOTTOMRIGHT", -10, -10)
	--[[
	Weight Sets Config Set up END
	]]--


	--[[
	Info Config Set up Begin
	]]--
	self.ConfigInfo = UI.CreateFrame("Text", "configInfoText", self.um_Tab1)
	self.ConfigInfo:SetFontSize(14)
	self.ConfigInfo:SetWordwrap(true)
	self.ConfigInfo:SetText(GetBuildInfo())
	self.ConfigInfo:SetPoint("TOPLEFT", self.um_Tab1, "TOPLEFT", 10, 10)
	self.ConfigInfo:SetPoint("BOTTOMRIGHT", self.um_Tab1, "BOTTOMRIGHT", -10, -10)
	--[[
	Info Config Set up Begin
	]]--
end

--function um_TabViewChanged(iTab)
--end

local function CancelOutfitClick(self)
	if self.Outfits:GetSelectedItem() then
		self:OutfitSelected(self.Outfits:GetSelectedItem(), nil, nil)
	else
		self:ClearConfigStats()
		self:ClearConfigInput()
	end
end

local function StartNewOutfitClick(self)
	self:ClearConfigStats()
	self:ClearConfigInput()
end

local function DeleteOutfitClick(self)
	_del = self.NewOutfit:GetText()
	if _del ~= "" and UM_GLOBAL.Outfits[_del] then
		UM_GLOBAL.Outfits[_del]["OutfitItems"] = nil
		UM_GLOBAL.Outfits[_del]["OutfitWeights"] = nil
		UM_GLOBAL.Outfits[_del] = nil
	end
	self:ClearConfigStats()
	self:ClearConfigInput()

	UM_GLOBAL.ValidateOutfit()
end

local function CreateOutfitClick(self, _newoutfit, _description)
	if not _newoutfit or _newoutfit == "" then
		print("You must enter outfit name and description to save.")
		return
	end

	local _temp = {}
	local _val = nil
	local _check = nil
	local _newstats = UM_GLOBAL.StatData.GetStatSet("blank", "blank")
	for stat, weight in pairs(_newstats) do
		_val = tonumber(self.StatWeights1[stat..""]:GetPosition())
		if _val and _val > 0 then
			_check = 1
			_temp[stat..""] = UM_GLOBAL.StatData.GetNewStatRecord()
			_temp[stat..""]["StatName"] = stat
			_temp[stat..""]["StatWeight1"] = self.StatWeights1[stat..""]:GetPosition()
		end
	end
    if not _check then
		print("You must set at least one stat > 0 to save.")
		return
	end

	UM_GLOBAL.Outfits[_newoutfit..""] = {["Name"]=_newoutfit, ["Description"]=_description, ["OutfitItems"]=UM_GLOBAL.OutfitData.NewEquipRecord(), ["OutfitWeights"]=nil}
	for slot, item in pairs(UM_GLOBAL.Outfits[_newoutfit..""]["OutfitItems"]) do
		_idetail = Inspect.Item.Detail(Utility.Item.Slot.Equipment(slot))
		if _idetail then
			item["Slot"]= slot
			item["Name"]= _idetail.name
			item["ID"] = _idetail.id
		end
	end
	UM_GLOBAL.Outfits[_newoutfit..""]["OutfitWeights"] = _temp
	UM_GLOBAL.flgTooltip = false

	self:StartNewOutfitClick()
end

local function SaveOutfit(self, _outfit)
	if not UM_GLOBAL.Outfits[_outfit] then
		print("Can't find outfit "..tostring(_outfit)..".  Please check your spelling or type /upme to find outfit.")
		return
	end

	for slot, item in pairs(UM_GLOBAL.Outfits[_outfit]["OutfitItems"]) do
		_idetail = Inspect.Item.Detail(Utility.Item.Slot.Equipment(slot))
		if _idetail then
			item["Slot"]= slot
			item["Name"]= _idetail.name
			item["ID"] = _idetail.id
		end
	end

	print("Outfit "..tostring(_outfit).." saved.")
end

local function OutfitSelected(item, value, index)
	self = UM_GLOBAL.Config
	self.SavedStats:SetSelectedIndex(-1, true)
	self:ClearConfigStats()

	self.NewOutfit:SetText(UM_GLOBAL.Outfits[value]["Name"])
	self.NewOutfitDescription:SetText(UM_GLOBAL.Outfits[value]["Description"])
	for stat, weight in pairs(UM_GLOBAL.Outfits[value]["OutfitWeights"]) do
		self.StatWeights1[stat]:SetPosition(tonumber(weight["StatWeight1"]))
	end
end

local function StatSetSelected(item, value, index)
	self = UM_GLOBAL.Config
	self:ClearConfigStats()
	for stat, weight in pairs(UM_GLOBAL.StatData.GetStatSet(UM_GLOBAL.Calling, value)) do
		self.StatWeights1[stat]:SetPosition(tonumber(weight["StatWeight1"]))
	end
end

local function ClearConfigInput(self)
	self.Outfits:SetItems(UM_GLOBAL.OutfitData.Outfits())
	self.SavedStats:SetItems(UM_GLOBAL.StatData.GetStatSets(UM_GLOBAL.Calling))
	self.NewOutfit:SetText("")
	self.NewOutfitDescription:SetText("")
	self.NewOutfit:SetKeyFocus(true)
end

local function ClearConfigStats(self)
	for i, fld in pairs(self.StatWeights1) do fld:SetPosition(0) end
end

local function Show(self, _tab)
	self:ClearConfigStats()
	self:ClearConfigInput()
	self.NewOutfit:SetKeyFocus(true)

	self:SetVisible(true)
	if _tab then self.um_TabView:SetActiveTab(_tab) end

end

local function Hide(self)
	self.NewOutfit:SetKeyFocus(true)
	self.NewOutfit:SetKeyFocus(false)
end

function GetConfig(_parent, _data)
	local _config = {}
	_config = UI.CreateFrame("SimpleWindow", "UpgradeMe", _parent)

	_config.Parent = _parent
	_config.Datasets = _data

	_config.BuildConfig = BuildConfig
	_config.CreateOutfitClick = CreateOutfitClick
	_config.SaveOutfit = SaveOutfit
	_config.CancelOutfitClick = CancelOutfitClick
	_config.DeleteOutfitClick = DeleteOutfitClick
	_config.StartNewOutfitClick = StartNewOutfitClick
	_config.OutfitSelected = OutfitSelected
	_config.StatSetSelected = StatSetSelected
	_config.ClearConfigStats = ClearConfigStats
	_config.ClearConfigInput = ClearConfigInput
	_config.Hide = Hide
	_config.Show = Show

	Library.LibSimpleWidgets.EventProxy(_config, {"Close"})

	_config:BuildConfig()
	return _config
end
