local addon, private = ...
local _equipset = {
					"helmet", "cape", "shoulders", "chest", "gloves",
					"belt", "legs", "feet", "handmain", "handoff",
					"ranged", "neck", "trinket", "ring1", "ring2", "synergy",
					"focus", "seal"
					}

local function sorter(a,b)
	return a[1] < b[1]
end

local function GetOutfits()
	local oReturn = {}
	for oname, outfit in pairs(UM_GLOBAL.Outfits) do
		table.insert(oReturn, oname)
	end
	return oReturn
end

local function GetEquipSet()
	return _equipset
end

local function GetNewEquipRecord()
	local _iRec = {}

	for i, slot in pairs(_equipset) do
		_iRec[slot..""] = {["slot"]=slot.."", ["Name"] = "", ["ID"] = nil}
	end
	return _iRec
end

local function GetOutfitCount()
	local _i = 0

	for oname, outfit in pairs(UM_GLOBAL.Outfits) do
		_i = _i + 1
	end

	return _i
end

function GetOutfitData()
	local _ret = {}

	_ret.Outfits = GetOutfits
	_ret.OutfitCount = GetOutfitCount
	_ret.EquipSet = GetEquipSet
	_ret.NewEquipRecord = GetNewEquipRecord

	return _ret
end
